/*******************************************************************************
 * Copyright (C) 2011 Filip Konecny
 * 
 * This file is part of NTS-lib-java.
 * 
 * NTS-lib-java is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * NTS-lib-java is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with NTS-lib-java.  If not, see <http://www.gnu.org/licenses/>.
 ******************************************************************************/
// $ANTLR 3.3 Nov 30, 2010 12:50:56 NTS.g 2012-03-22 09:56:22

package nts.parser;

import nts.interf.base.*;
import java.util.LinkedList;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

@SuppressWarnings("unused")
public class NTSParser extends MBaseParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "IDN", "IDP", "LITINT", "LITREAL", "CALL", "NTS", "AT", "QUOTE", "TRUE", "FALSE", "NOT", "AND", "OR", "IMPL", "EQUIV", "C_NOT", "C_AND", "C_OR", "C_IMPL", "C_EQUIV", "EXISTS", "FORALL", "EQ", "NEQ", "LEQ", "LT", "GEQ", "GT", "VBAR", "PLUS", "MINUS", "MULT", "DIVIDE", "REMAINDER", "LPAR", "RPAR", "LPAR_S", "RPAR_S", "LPAR_C", "RPAR_C", "DOT", "COMMA", "COLON", "SEMICOLON", "TBOOL", "TINT", "TREAL", "TSTRING", "TFORMULA", "PARAM", "IN", "OUT", "STATES", "INITIAL", "FINAL", "ERROR", "PRECONDITION", "INSTANCES", "HAVOC", "TID", "RELATION", "ARR_LENGTH", "LITSTRING", "WS", "SINGLE_COMMENT", "ML_COMMENT"
    };
    public static final int EOF=-1;
    public static final int IDN=4;
    public static final int IDP=5;
    public static final int LITINT=6;
    public static final int LITREAL=7;
    public static final int CALL=8;
    public static final int NTS=9;
    public static final int AT=10;
    public static final int QUOTE=11;
    public static final int TRUE=12;
    public static final int FALSE=13;
    public static final int NOT=14;
    public static final int AND=15;
    public static final int OR=16;
    public static final int IMPL=17;
    public static final int EQUIV=18;
    public static final int C_NOT=19;
    public static final int C_AND=20;
    public static final int C_OR=21;
    public static final int C_IMPL=22;
    public static final int C_EQUIV=23;
    public static final int EXISTS=24;
    public static final int FORALL=25;
    public static final int EQ=26;
    public static final int NEQ=27;
    public static final int LEQ=28;
    public static final int LT=29;
    public static final int GEQ=30;
    public static final int GT=31;
    public static final int VBAR=32;
    public static final int PLUS=33;
    public static final int MINUS=34;
    public static final int MULT=35;
    public static final int DIVIDE=36;
    public static final int REMAINDER=37;
    public static final int LPAR=38;
    public static final int RPAR=39;
    public static final int LPAR_S=40;
    public static final int RPAR_S=41;
    public static final int LPAR_C=42;
    public static final int RPAR_C=43;
    public static final int DOT=44;
    public static final int COMMA=45;
    public static final int COLON=46;
    public static final int SEMICOLON=47;
    public static final int TBOOL=48;
    public static final int TINT=49;
    public static final int TREAL=50;
    public static final int TSTRING=51;
    public static final int TFORMULA=52;
    public static final int PARAM=53;
    public static final int IN=54;
    public static final int OUT=55;
    public static final int STATES=56;
    public static final int INITIAL=57;
    public static final int FINAL=58;
    public static final int ERROR=59;
    public static final int PRECONDITION=60;
    public static final int INSTANCES=61;
    public static final int HAVOC=62;
    public static final int TID=63;
    public static final int RELATION=64;
    public static final int ARR_LENGTH=65;
    public static final int LITSTRING=66;
    public static final int WS=67;
    public static final int SINGLE_COMMENT=68;
    public static final int ML_COMMENT=69;

    // delegates
    // delegators


        public NTSParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public NTSParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return NTSParser.tokenNames; }
    public String getGrammarFileName() { return "NTS.g"; }



      private IParserListener listener;

      public NTSParser(TokenStream input, IParserListener aListener) {
        this(input);
        listener = aListener;
      }

      public static void parseExpr(java.io.InputStream is, IParserListener aListener) {
        try { 
          ANTLRInputStream input = new ANTLRInputStream(is);
          NTSLexer lexer = new NTSLexer(input);
          CommonTokenStream tokens = new CommonTokenStream(lexer);
          NTSParser parser = new NTSParser(tokens, aListener);
          Common.parser = parser;
          try {
            // initialize the listener
            aListener.exprParsingInit();
            NTSParser.start_expr_return r = parser.start_expr();
            aListener.exprParsingFinalize();
          } catch (RecognitionException e) {
            System.err.print(e.getMessage());
            System.exit(1);
          }
        } catch (java.io.IOException e) {
          System.err.print(e.getMessage());
          System.exit(1);  
        }    
      }

      public static void parseNTS(java.io.InputStream is, IParserListener aListener) {
        try { 
          ANTLRInputStream input = new ANTLRInputStream(is);
          NTSLexer lexer = new NTSLexer(input);
          CommonTokenStream tokens = new CommonTokenStream(lexer);
          NTSParser parser = new NTSParser(tokens, aListener);
          Common.parser = parser;
          try {
            NTSParser.start_return r = parser.start();
            //System.out.println(r.getTree().toStringTree());
          } catch (RecognitionException e) {
            System.err.print(e.getMessage());
            System.exit(1);
          }
        } catch (java.io.IOException e) {
          System.err.print(e.getMessage());
          System.exit(1);  
        }
        
      }
      
      private static CommonToken dummy(int n, String aText) {
        CommonToken t = new CommonToken(n);
        t.setText(aText);
        return t;
      }
      public boolean isPrimedId(Token aToken) {
        return aToken.getType() == IDP;
      }
      public CommonToken dummyLparS() {
      	return dummy(LPAR_S,"[");
      }
      public CommonToken dummyTrue() {
        return dummy(TRUE,"true");
      }
      public CommonToken dummyAnd() {
        return dummy(AND,"and");
      }
      public CommonToken dummyImpl() {
        return dummy(IMPL,"impl");
      }
      public CommonToken dummyEquiv() {
        return dummy(EQUIV,"equiv");
      }
      public CommonToken dummyLeq() {
        return dummy(LEQ,"<=");
      }
      public CommonToken dummyTid() {
        return dummy(TID,"tid");
      }
      public CommonToken dummyIDN(String s) {
        return dummy(IDN, s);
      }
      public CommonToken dummyIDP(String s) {
        return dummy(IDP, s);
      }
      public static CommonToken dummyIDN_S(String s) {
        return dummy(IDN, s);
      }
      public static CommonToken dummyIDP_S(String s) {
        return dummy(IDP, s);
      }

      public static CommonToken dummyPrimed(CommonToken aToken) {
        CommonToken t = new CommonToken(aToken);
        t.setType(IDP);
        t.setText(t.getText()+'\'');
        return t;
      }
      public CommonToken dummyNum(int aVal) {
        CommonToken t = new CommonToken(LITINT);
        t.setText(""+aVal);
        return t;
      }
      public EModifier token2modifier(Token aToken) {
        switch (aToken.getType()) {
        case PARAM:
          return EModifier.PARAM;
        case IN:
          return EModifier.IN;
        case OUT:
          return EModifier.OUT;
        case TID:
          return EModifier.TID;
        default:
          throw new RuntimeException("internal error: unexpected token type '"+aToken+"'.");
        }
      }
      public EBasicType token2basicType(Token aToken) {
        switch (aToken.getType()) {
        case TBOOL:
          return EBasicType.BOOL;
        case TINT:
          return EBasicType.INT;
        case TREAL:
          return EBasicType.REAL;
        default:
          throw new RuntimeException("internal error: unexpected token type '"+aToken+"'.");
        }
      }
      public EAnnotType token2annotType(Token aToken) {
        switch (aToken.getType()) {
        case TINT:
          return EAnnotType.INT;
        case TREAL:
          return EAnnotType.REAL;
        case TBOOL:
          return EAnnotType.BOOL;
        case TSTRING:
          return EAnnotType.STRING;
        case TFORMULA:
          return EAnnotType.FORMULA;
        default:
          throw new RuntimeException("internal error: unexpected token type '"+aToken+"'.");
        }
      }
      
      public EMarkType token2markType(Token aToken) {
        switch (aToken.getType()) {
        case INITIAL:
          return EMarkType.INITIAL;
        case FINAL:
          return EMarkType.FINAL;
        case ERROR:
          return EMarkType.ERROR;
        default:
          throw new RuntimeException("internal error");
        }
      }
      

      /**
       * Used as a semantic predicate to distinguish between calls and formulae
       * (needs 4 tokens look-ahead)
       */
      boolean isCall() {
        int LA1 = input.LA(1);
        int LA2 = input.LA(2);
        int LA3 = input.LA(3);
        int LA4 = input.LA(4);
        return 
          (LA1 == IDN && LA2 == LPAR) ||                              // f( ...
          (LA1 == LPAR && LA2 == IDP && LA3 == COMMA) ||              // (x', ...
          (LA1 == LPAR && LA2 == IDP && LA3 == RPAR && LA4 == EQ) ||  // (x')= ...
          (LA1 == IDP && LA2 == EQ && LA3 == IDN && LA4 == LPAR);     // x'=f( ...
      }
      

    /*  
      protected void mismatch(IntStream input, int ttype, BitSet follow)
      throws RecognitionException {
        throw new MismatchedTokenException(ttype, input);
      }
      public Object recoverFromMismatchedSet(IntStream input, RecognitionException e, BitSet follow)
      throws RecognitionException {
        throw e;
      }
    */
      public void reportError(RecognitionException ex) {
        super.reportError(ex);
        System.exit(1);
      }
      


    public static class start_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "start"
    // NTS.g:331:1: start : nts EOF ;
    public final NTSParser.start_return start() throws RecognitionException {
        NTSParser.start_return retval = new NTSParser.start_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EOF2=null;
        NTSParser.nts_return nts1 = null;


        CommonTree EOF2_tree=null;

        try {
            // NTS.g:332:3: ( nts EOF )
            // NTS.g:332:5: nts EOF
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_nts_in_start687);
            nts1=nts();

            state._fsp--;

            adaptor.addChild(root_0, nts1.getTree());
            EOF2=(Token)match(input,EOF,FOLLOW_EOF_in_start689); 
            EOF2_tree = (CommonTree)adaptor.create(EOF2);
            adaptor.addChild(root_0, EOF2_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "start"

    public static class start_expr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "start_expr"
    // NTS.g:335:1: start_expr : declar RELATION ( expr SEMICOLON )+ EOF ;
    public final NTSParser.start_expr_return start_expr() throws RecognitionException {
        NTSParser.start_expr_return retval = new NTSParser.start_expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token RELATION4=null;
        Token SEMICOLON6=null;
        Token EOF7=null;
        NTSParser.declar_return declar3 = null;

        NTSParser.expr_return expr5 = null;


        CommonTree RELATION4_tree=null;
        CommonTree SEMICOLON6_tree=null;
        CommonTree EOF7_tree=null;

        try {
            // NTS.g:336:3: ( declar RELATION ( expr SEMICOLON )+ EOF )
            // NTS.g:336:5: declar RELATION ( expr SEMICOLON )+ EOF
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_declar_in_start_expr702);
            declar3=declar();

            state._fsp--;

            adaptor.addChild(root_0, declar3.getTree());
            RELATION4=(Token)match(input,RELATION,FOLLOW_RELATION_in_start_expr704); 
            RELATION4_tree = (CommonTree)adaptor.create(RELATION4);
            adaptor.addChild(root_0, RELATION4_tree);

            // NTS.g:336:21: ( expr SEMICOLON )+
            int cnt1=0;
            loop1:
            do {
                int alt1=2;
                alt1 = dfa1.predict(input);
                switch (alt1) {
            	case 1 :
            	    // NTS.g:336:22: expr SEMICOLON
            	    {
            	    pushFollow(FOLLOW_expr_in_start_expr707);
            	    expr5=expr();

            	    state._fsp--;

            	    adaptor.addChild(root_0, expr5.getTree());
            	    SEMICOLON6=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_start_expr709); 
            	    SEMICOLON6_tree = (CommonTree)adaptor.create(SEMICOLON6);
            	    adaptor.addChild(root_0, SEMICOLON6_tree);


            	    }
            	    break;

            	default :
            	    if ( cnt1 >= 1 ) break loop1;
                        EarlyExitException eee =
                            new EarlyExitException(1, input);
                        throw eee;
                }
                cnt1++;
            } while (true);

            EOF7=(Token)match(input,EOF,FOLLOW_EOF_in_start_expr713); 
            EOF7_tree = (CommonTree)adaptor.create(EOF7);
            adaptor.addChild(root_0, EOF7_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "start_expr"

    public static class nts_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "nts"
    // NTS.g:344:1: nts : annotations NTS IDN SEMICOLON ma= modif_annot ( declar_m_a )? ( precondition annotations )? ( instances annotations )? subsystem_annot ( subsystem )* ;
    public final NTSParser.nts_return nts() throws RecognitionException {
        NTSParser.nts_return retval = new NTSParser.nts_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token NTS9=null;
        Token IDN10=null;
        Token SEMICOLON11=null;
        NTSParser.modif_annot_return ma = null;

        NTSParser.annotations_return annotations8 = null;

        NTSParser.declar_m_a_return declar_m_a12 = null;

        NTSParser.precondition_return precondition13 = null;

        NTSParser.annotations_return annotations14 = null;

        NTSParser.instances_return instances15 = null;

        NTSParser.annotations_return annotations16 = null;

        NTSParser.subsystem_annot_return subsystem_annot17 = null;

        NTSParser.subsystem_return subsystem18 = null;


        CommonTree NTS9_tree=null;
        CommonTree IDN10_tree=null;
        CommonTree SEMICOLON11_tree=null;

        try {
            // NTS.g:345:3: ( annotations NTS IDN SEMICOLON ma= modif_annot ( declar_m_a )? ( precondition annotations )? ( instances annotations )? subsystem_annot ( subsystem )* )
            // NTS.g:346:5: annotations NTS IDN SEMICOLON ma= modif_annot ( declar_m_a )? ( precondition annotations )? ( instances annotations )? subsystem_annot ( subsystem )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_annotations_in_nts736);
            annotations8=annotations();

            state._fsp--;

            adaptor.addChild(root_0, annotations8.getTree());
            NTS9=(Token)match(input,NTS,FOLLOW_NTS_in_nts747); 
            NTS9_tree = (CommonTree)adaptor.create(NTS9);
            adaptor.addChild(root_0, NTS9_tree);

            IDN10=(Token)match(input,IDN,FOLLOW_IDN_in_nts749); 
            IDN10_tree = (CommonTree)adaptor.create(IDN10);
            adaptor.addChild(root_0, IDN10_tree);

            SEMICOLON11=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_nts751); 
            SEMICOLON11_tree = (CommonTree)adaptor.create(SEMICOLON11);
            adaptor.addChild(root_0, SEMICOLON11_tree);

             listener.ntsInit(IDN10); 
            pushFollow(FOLLOW_modif_annot_in_nts791);
            ma=modif_annot();

            state._fsp--;

            adaptor.addChild(root_0, ma.getTree());
            // NTS.g:358:5: ( declar_m_a )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==IDN) ) {
                int LA2_1 = input.LA(2);

                if ( (LA2_1==LPAR_S||(LA2_1>=COMMA && LA2_1<=COLON)) ) {
                    alt2=1;
                }
            }
            switch (alt2) {
                case 1 :
                    // NTS.g:358:7: declar_m_a
                    {
                    pushFollow(FOLLOW_declar_m_a_in_nts809);
                    declar_m_a12=declar_m_a();

                    state._fsp--;

                    adaptor.addChild(root_0, declar_m_a12.getTree());

                    }
                    break;

            }

             listener.checkNoModifier(); 
            // NTS.g:364:5: ( precondition annotations )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==PRECONDITION) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // NTS.g:364:7: precondition annotations
                    {
                     listener.checkNoAnnotation(); 
                    pushFollow(FOLLOW_precondition_in_nts854);
                    precondition13=precondition();

                    state._fsp--;

                    adaptor.addChild(root_0, precondition13.getTree());
                    pushFollow(FOLLOW_annotations_in_nts869);
                    annotations14=annotations();

                    state._fsp--;

                    adaptor.addChild(root_0, annotations14.getTree());

                    }
                    break;

            }

            // NTS.g:371:5: ( instances annotations )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==INSTANCES) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // NTS.g:371:7: instances annotations
                    {
                     listener.checkNoAnnotation(); 
                    pushFollow(FOLLOW_instances_in_nts902);
                    instances15=instances();

                    state._fsp--;

                    adaptor.addChild(root_0, instances15.getTree());
                    pushFollow(FOLLOW_annotations_in_nts917);
                    annotations16=annotations();

                    state._fsp--;

                    adaptor.addChild(root_0, annotations16.getTree());

                    }
                    break;

            }

            pushFollow(FOLLOW_subsystem_annot_in_nts940);
            subsystem_annot17=subsystem_annot();

            state._fsp--;

            adaptor.addChild(root_0, subsystem_annot17.getTree());
            // NTS.g:378:21: ( subsystem )*
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==IDN||LA5_0==AT) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // NTS.g:378:23: subsystem
            	    {
            	    pushFollow(FOLLOW_subsystem_in_nts944);
            	    subsystem18=subsystem();

            	    state._fsp--;

            	    adaptor.addChild(root_0, subsystem18.getTree());

            	    }
            	    break;

            	default :
            	    break loop5;
                }
            } while (true);

             listener.ntsFinalize(); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "nts"

    public static class precondition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "precondition"
    // NTS.g:382:1: precondition : PRECONDITION expr SEMICOLON ;
    public final NTSParser.precondition_return precondition() throws RecognitionException {
        NTSParser.precondition_return retval = new NTSParser.precondition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token PRECONDITION19=null;
        Token SEMICOLON21=null;
        NTSParser.expr_return expr20 = null;


        CommonTree PRECONDITION19_tree=null;
        CommonTree SEMICOLON21_tree=null;

        try {
            // NTS.g:383:3: ( PRECONDITION expr SEMICOLON )
            // NTS.g:383:5: PRECONDITION expr SEMICOLON
            {
            root_0 = (CommonTree)adaptor.nil();

            PRECONDITION19=(Token)match(input,PRECONDITION,FOLLOW_PRECONDITION_in_precondition970); 
            PRECONDITION19_tree = (CommonTree)adaptor.create(PRECONDITION19);
            adaptor.addChild(root_0, PRECONDITION19_tree);

            pushFollow(FOLLOW_expr_in_precondition972);
            expr20=expr();

            state._fsp--;

            adaptor.addChild(root_0, expr20.getTree());
            SEMICOLON21=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_precondition974); 
            SEMICOLON21_tree = (CommonTree)adaptor.create(SEMICOLON21);
            adaptor.addChild(root_0, SEMICOLON21_tree);

             listener.precondition(); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "precondition"

    public static class instances_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "instances"
    // NTS.g:385:1: instances : INSTANCES inst ( COMMA inst )* SEMICOLON ;
    public final NTSParser.instances_return instances() throws RecognitionException {
        NTSParser.instances_return retval = new NTSParser.instances_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token INSTANCES22=null;
        Token COMMA24=null;
        Token SEMICOLON26=null;
        NTSParser.inst_return inst23 = null;

        NTSParser.inst_return inst25 = null;


        CommonTree INSTANCES22_tree=null;
        CommonTree COMMA24_tree=null;
        CommonTree SEMICOLON26_tree=null;

        try {
            // NTS.g:386:3: ( INSTANCES inst ( COMMA inst )* SEMICOLON )
            // NTS.g:386:5: INSTANCES inst ( COMMA inst )* SEMICOLON
            {
            root_0 = (CommonTree)adaptor.nil();

            INSTANCES22=(Token)match(input,INSTANCES,FOLLOW_INSTANCES_in_instances989); 
            INSTANCES22_tree = (CommonTree)adaptor.create(INSTANCES22);
            adaptor.addChild(root_0, INSTANCES22_tree);

            pushFollow(FOLLOW_inst_in_instances991);
            inst23=inst();

            state._fsp--;

            adaptor.addChild(root_0, inst23.getTree());
            // NTS.g:386:20: ( COMMA inst )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==COMMA) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // NTS.g:386:21: COMMA inst
            	    {
            	    COMMA24=(Token)match(input,COMMA,FOLLOW_COMMA_in_instances994); 
            	    COMMA24_tree = (CommonTree)adaptor.create(COMMA24);
            	    adaptor.addChild(root_0, COMMA24_tree);

            	    pushFollow(FOLLOW_inst_in_instances996);
            	    inst25=inst();

            	    state._fsp--;

            	    adaptor.addChild(root_0, inst25.getTree());

            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

            SEMICOLON26=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_instances1000); 
            SEMICOLON26_tree = (CommonTree)adaptor.create(SEMICOLON26);
            adaptor.addChild(root_0, SEMICOLON26_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "instances"

    public static class inst_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "inst"
    // NTS.g:388:1: inst : ii= IDN LPAR_S ee= expr RPAR_S ;
    public final NTSParser.inst_return inst() throws RecognitionException {
        NTSParser.inst_return retval = new NTSParser.inst_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token ii=null;
        Token LPAR_S27=null;
        Token RPAR_S28=null;
        NTSParser.expr_return ee = null;


        CommonTree ii_tree=null;
        CommonTree LPAR_S27_tree=null;
        CommonTree RPAR_S28_tree=null;

        try {
            // NTS.g:389:3: (ii= IDN LPAR_S ee= expr RPAR_S )
            // NTS.g:389:5: ii= IDN LPAR_S ee= expr RPAR_S
            {
            root_0 = (CommonTree)adaptor.nil();

            ii=(Token)match(input,IDN,FOLLOW_IDN_in_inst1014); 
            ii_tree = (CommonTree)adaptor.create(ii);
            adaptor.addChild(root_0, ii_tree);

            LPAR_S27=(Token)match(input,LPAR_S,FOLLOW_LPAR_S_in_inst1016); 
            LPAR_S27_tree = (CommonTree)adaptor.create(LPAR_S27);
            adaptor.addChild(root_0, LPAR_S27_tree);

            pushFollow(FOLLOW_expr_in_inst1020);
            ee=expr();

            state._fsp--;

            adaptor.addChild(root_0, ee.getTree());
            RPAR_S28=(Token)match(input,RPAR_S,FOLLOW_RPAR_S_in_inst1022); 
            RPAR_S28_tree = (CommonTree)adaptor.create(RPAR_S28);
            adaptor.addChild(root_0, RPAR_S28_tree);

             listener.instance(ii); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "inst"

    public static class annotations_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotations"
    // NTS.g:399:1: annotations : (a1= annotation ( annotation )* | );
    public final NTSParser.annotations_return annotations() throws RecognitionException {
        NTSParser.annotations_return retval = new NTSParser.annotations_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.annotation_return a1 = null;

        NTSParser.annotation_return annotation29 = null;



        try {
            // NTS.g:400:3: (a1= annotation ( annotation )* | )
            int alt8=2;
            alt8 = dfa8.predict(input);
            switch (alt8) {
                case 1 :
                    // NTS.g:400:5: a1= annotation ( annotation )*
                    {
                    root_0 = (CommonTree)adaptor.nil();

                     listener.setAnnotations(new Annotations()); 
                    pushFollow(FOLLOW_annotation_in_annotations1055);
                    a1=annotation();

                    state._fsp--;

                    adaptor.addChild(root_0, a1.getTree());
                     listener.setAnnotFirstTok((a1!=null?((Token)a1.start):null)); 
                    // NTS.g:402:5: ( annotation )*
                    loop7:
                    do {
                        int alt7=2;
                        alt7 = dfa7.predict(input);
                        switch (alt7) {
                    	case 1 :
                    	    // NTS.g:402:7: annotation
                    	    {
                    	    pushFollow(FOLLOW_annotation_in_annotations1065);
                    	    annotation29=annotation();

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, annotation29.getTree());

                    	    }
                    	    break;

                    	default :
                    	    break loop7;
                        }
                    } while (true);


                    }
                    break;
                case 2 :
                    // NTS.g:403:5: 
                    {
                    root_0 = (CommonTree)adaptor.nil();

                     listener.setAnnotations(null); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "annotations"

    public static class annotation_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annotation"
    // NTS.g:405:1: annotation : AT k= IDN COLON t= annot_type COLON annot_value[$k, $t.rT] SEMICOLON ;
    public final NTSParser.annotation_return annotation() throws RecognitionException {
        NTSParser.annotation_return retval = new NTSParser.annotation_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token k=null;
        Token AT30=null;
        Token COLON31=null;
        Token COLON32=null;
        Token SEMICOLON34=null;
        NTSParser.annot_type_return t = null;

        NTSParser.annot_value_return annot_value33 = null;


        CommonTree k_tree=null;
        CommonTree AT30_tree=null;
        CommonTree COLON31_tree=null;
        CommonTree COLON32_tree=null;
        CommonTree SEMICOLON34_tree=null;

        try {
            // NTS.g:406:3: ( AT k= IDN COLON t= annot_type COLON annot_value[$k, $t.rT] SEMICOLON )
            // NTS.g:406:5: AT k= IDN COLON t= annot_type COLON annot_value[$k, $t.rT] SEMICOLON
            {
            root_0 = (CommonTree)adaptor.nil();

            AT30=(Token)match(input,AT,FOLLOW_AT_in_annotation1087); 
            AT30_tree = (CommonTree)adaptor.create(AT30);
            adaptor.addChild(root_0, AT30_tree);

            k=(Token)match(input,IDN,FOLLOW_IDN_in_annotation1091); 
            k_tree = (CommonTree)adaptor.create(k);
            adaptor.addChild(root_0, k_tree);

            COLON31=(Token)match(input,COLON,FOLLOW_COLON_in_annotation1093); 
            COLON31_tree = (CommonTree)adaptor.create(COLON31);
            adaptor.addChild(root_0, COLON31_tree);

            pushFollow(FOLLOW_annot_type_in_annotation1101);
            t=annot_type();

            state._fsp--;

            adaptor.addChild(root_0, t.getTree());
            COLON32=(Token)match(input,COLON,FOLLOW_COLON_in_annotation1103); 
            COLON32_tree = (CommonTree)adaptor.create(COLON32);
            adaptor.addChild(root_0, COLON32_tree);

            pushFollow(FOLLOW_annot_value_in_annotation1110);
            annot_value33=annot_value(k, (t!=null?t.rT:null));

            state._fsp--;

            adaptor.addChild(root_0, annot_value33.getTree());
            SEMICOLON34=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_annotation1113); 
            SEMICOLON34_tree = (CommonTree)adaptor.create(SEMICOLON34);
            adaptor.addChild(root_0, SEMICOLON34_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "annotation"

    public static class annot_value_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annot_value"
    // NTS.g:411:1: annot_value[Token aKey, EAnnotType aT] : (s= litstring | e= expr );
    public final NTSParser.annot_value_return annot_value(Token aKey, EAnnotType aT) throws RecognitionException {
        NTSParser.annot_value_return retval = new NTSParser.annot_value_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.litstring_return s = null;

        NTSParser.expr_return e = null;



        try {
            // NTS.g:412:3: (s= litstring | e= expr )
            int alt9=2;
            alt9 = dfa9.predict(input);
            switch (alt9) {
                case 1 :
                    // NTS.g:412:5: s= litstring
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_litstring_in_annot_value1130);
                    s=litstring();

                    state._fsp--;

                    adaptor.addChild(root_0, s.getTree());
                     listener.addAnnotString(aKey, aT, (s!=null?s.rS:null)); 

                    }
                    break;
                case 2 :
                    // NTS.g:413:5: e= expr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_expr_in_annot_value1140);
                    e=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, e.getTree());
                     listener.addAnnotIntRealBoolFormula(aKey, aT); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "annot_value"

    public static class annot_type_return extends ParserRuleReturnScope {
        public EAnnotType rT;
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "annot_type"
    // NTS.g:415:1: annot_type returns [EAnnotType rT] : t= ( TINT | TREAL | TBOOL | TSTRING | TFORMULA ) ;
    public final NTSParser.annot_type_return annot_type() throws RecognitionException {
        NTSParser.annot_type_return retval = new NTSParser.annot_type_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token t=null;

        CommonTree t_tree=null;

        try {
            // NTS.g:416:3: (t= ( TINT | TREAL | TBOOL | TSTRING | TFORMULA ) )
            // NTS.g:416:5: t= ( TINT | TREAL | TBOOL | TSTRING | TFORMULA )
            {
            root_0 = (CommonTree)adaptor.nil();

            t=(Token)input.LT(1);
            if ( (input.LA(1)>=TBOOL && input.LA(1)<=TFORMULA) ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(t));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

             retval.rT = token2annotType(t); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "annot_type"

    public static class litstring_return extends ParserRuleReturnScope {
        public String rS;
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "litstring"
    // NTS.g:418:1: litstring returns [String rS] : l= LITSTRING ;
    public final NTSParser.litstring_return litstring() throws RecognitionException {
        NTSParser.litstring_return retval = new NTSParser.litstring_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token l=null;

        CommonTree l_tree=null;

        try {
            // NTS.g:419:3: (l= LITSTRING )
            // NTS.g:419:5: l= LITSTRING
            {
            root_0 = (CommonTree)adaptor.nil();

            l=(Token)match(input,LITSTRING,FOLLOW_LITSTRING_in_litstring1198); 
            l_tree = (CommonTree)adaptor.create(l);
            adaptor.addChild(root_0, l_tree);

             
                  retval.rS = l.getText();
                  retval.rS = retval.rS.substring(1,retval.rS.length()-2);
                

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "litstring"

    public static class subsystem_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "subsystem"
    // NTS.g:430:1: subsystem : annotations subsystem_annot ;
    public final NTSParser.subsystem_return subsystem() throws RecognitionException {
        NTSParser.subsystem_return retval = new NTSParser.subsystem_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.annotations_return annotations35 = null;

        NTSParser.subsystem_annot_return subsystem_annot36 = null;



        try {
            // NTS.g:431:3: ( annotations subsystem_annot )
            // NTS.g:431:5: annotations subsystem_annot
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_annotations_in_subsystem1222);
            annotations35=annotations();

            state._fsp--;

            adaptor.addChild(root_0, annotations35.getTree());
            pushFollow(FOLLOW_subsystem_annot_in_subsystem1224);
            subsystem_annot36=subsystem_annot();

            state._fsp--;

            adaptor.addChild(root_0, subsystem_annot36.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "subsystem"

    public static class subsystem_annot_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "subsystem_annot"
    // NTS.g:433:1: subsystem_annot : IDN LPAR_C ( declar )? ( marking )? ( transition )+ RPAR_C ;
    public final NTSParser.subsystem_annot_return subsystem_annot() throws RecognitionException {
        NTSParser.subsystem_annot_return retval = new NTSParser.subsystem_annot_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IDN37=null;
        Token LPAR_C38=null;
        Token RPAR_C42=null;
        NTSParser.declar_return declar39 = null;

        NTSParser.marking_return marking40 = null;

        NTSParser.transition_return transition41 = null;


        CommonTree IDN37_tree=null;
        CommonTree LPAR_C38_tree=null;
        CommonTree RPAR_C42_tree=null;

        try {
            // NTS.g:434:3: ( IDN LPAR_C ( declar )? ( marking )? ( transition )+ RPAR_C )
            // NTS.g:434:5: IDN LPAR_C ( declar )? ( marking )? ( transition )+ RPAR_C
            {
            root_0 = (CommonTree)adaptor.nil();

            IDN37=(Token)match(input,IDN,FOLLOW_IDN_in_subsystem_annot1236); 
            IDN37_tree = (CommonTree)adaptor.create(IDN37);
            adaptor.addChild(root_0, IDN37_tree);

            LPAR_C38=(Token)match(input,LPAR_C,FOLLOW_LPAR_C_in_subsystem_annot1238); 
            LPAR_C38_tree = (CommonTree)adaptor.create(LPAR_C38);
            adaptor.addChild(root_0, LPAR_C38_tree);

             listener.subsystemInit(IDN37); 
            // NTS.g:437:5: ( declar )?
            int alt10=2;
            alt10 = dfa10.predict(input);
            switch (alt10) {
                case 1 :
                    // NTS.g:437:5: declar
                    {
                    pushFollow(FOLLOW_declar_in_subsystem_annot1256);
                    declar39=declar();

                    state._fsp--;

                    adaptor.addChild(root_0, declar39.getTree());

                    }
                    break;

            }

            // NTS.g:439:5: ( marking )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( ((LA11_0>=STATES && LA11_0<=ERROR)) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // NTS.g:439:7: marking
                    {
                    pushFollow(FOLLOW_marking_in_subsystem_annot1270);
                    marking40=marking();

                    state._fsp--;

                    adaptor.addChild(root_0, marking40.getTree());

                    }
                    break;

            }

            // NTS.g:439:18: ( transition )+
            int cnt12=0;
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==IDN) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // NTS.g:439:20: transition
            	    {
            	    pushFollow(FOLLOW_transition_in_subsystem_annot1277);
            	    transition41=transition();

            	    state._fsp--;

            	    adaptor.addChild(root_0, transition41.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt12 >= 1 ) break loop12;
                        EarlyExitException eee =
                            new EarlyExitException(12, input);
                        throw eee;
                }
                cnt12++;
            } while (true);

            RPAR_C42=(Token)match(input,RPAR_C,FOLLOW_RPAR_C_in_subsystem_annot1282); 
            RPAR_C42_tree = (CommonTree)adaptor.create(RPAR_C42);
            adaptor.addChild(root_0, RPAR_C42_tree);

             listener.subsystemFinalize(); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "subsystem_annot"

    public static class marking_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "marking"
    // NTS.g:442:1: marking : ( STATES annotations i1= IDN ( COMMA annotations i2= IDN )* SEMICOLON )? (m= ( INITIAL | FINAL | ERROR ) i1= IDN ( COMMA i2= IDN )* semi= SEMICOLON )+ ;
    public final NTSParser.marking_return marking() throws RecognitionException {
        NTSParser.marking_return retval = new NTSParser.marking_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token i1=null;
        Token i2=null;
        Token m=null;
        Token semi=null;
        Token STATES43=null;
        Token COMMA45=null;
        Token SEMICOLON47=null;
        Token COMMA48=null;
        NTSParser.annotations_return annotations44 = null;

        NTSParser.annotations_return annotations46 = null;


        CommonTree i1_tree=null;
        CommonTree i2_tree=null;
        CommonTree m_tree=null;
        CommonTree semi_tree=null;
        CommonTree STATES43_tree=null;
        CommonTree COMMA45_tree=null;
        CommonTree SEMICOLON47_tree=null;
        CommonTree COMMA48_tree=null;

        try {
            // NTS.g:443:3: ( ( STATES annotations i1= IDN ( COMMA annotations i2= IDN )* SEMICOLON )? (m= ( INITIAL | FINAL | ERROR ) i1= IDN ( COMMA i2= IDN )* semi= SEMICOLON )+ )
            // NTS.g:443:5: ( STATES annotations i1= IDN ( COMMA annotations i2= IDN )* SEMICOLON )? (m= ( INITIAL | FINAL | ERROR ) i1= IDN ( COMMA i2= IDN )* semi= SEMICOLON )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // NTS.g:443:5: ( STATES annotations i1= IDN ( COMMA annotations i2= IDN )* SEMICOLON )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==STATES) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // NTS.g:443:7: STATES annotations i1= IDN ( COMMA annotations i2= IDN )* SEMICOLON
                    {
                    STATES43=(Token)match(input,STATES,FOLLOW_STATES_in_marking1302); 
                    STATES43_tree = (CommonTree)adaptor.create(STATES43);
                    adaptor.addChild(root_0, STATES43_tree);

                    pushFollow(FOLLOW_annotations_in_marking1310);
                    annotations44=annotations();

                    state._fsp--;

                    adaptor.addChild(root_0, annotations44.getTree());
                    i1=(Token)match(input,IDN,FOLLOW_IDN_in_marking1314); 
                    i1_tree = (CommonTree)adaptor.create(i1);
                    adaptor.addChild(root_0, i1_tree);

                     listener.stateDeclaration(i1); 
                    // NTS.g:445:7: ( COMMA annotations i2= IDN )*
                    loop13:
                    do {
                        int alt13=2;
                        int LA13_0 = input.LA(1);

                        if ( (LA13_0==COMMA) ) {
                            alt13=1;
                        }


                        switch (alt13) {
                    	case 1 :
                    	    // NTS.g:445:9: COMMA annotations i2= IDN
                    	    {
                    	    COMMA45=(Token)match(input,COMMA,FOLLOW_COMMA_in_marking1326); 
                    	    COMMA45_tree = (CommonTree)adaptor.create(COMMA45);
                    	    adaptor.addChild(root_0, COMMA45_tree);

                    	    pushFollow(FOLLOW_annotations_in_marking1328);
                    	    annotations46=annotations();

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, annotations46.getTree());
                    	    i2=(Token)match(input,IDN,FOLLOW_IDN_in_marking1332); 
                    	    i2_tree = (CommonTree)adaptor.create(i2);
                    	    adaptor.addChild(root_0, i2_tree);

                    	     listener.stateDeclaration(i2); 

                    	    }
                    	    break;

                    	default :
                    	    break loop13;
                        }
                    } while (true);

                    SEMICOLON47=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_marking1351); 
                    SEMICOLON47_tree = (CommonTree)adaptor.create(SEMICOLON47);
                    adaptor.addChild(root_0, SEMICOLON47_tree);


                    }
                    break;

            }

            // NTS.g:450:5: (m= ( INITIAL | FINAL | ERROR ) i1= IDN ( COMMA i2= IDN )* semi= SEMICOLON )+
            int cnt16=0;
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( ((LA16_0>=INITIAL && LA16_0<=ERROR)) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // NTS.g:451:7: m= ( INITIAL | FINAL | ERROR ) i1= IDN ( COMMA i2= IDN )* semi= SEMICOLON
            	    {
            	    m=(Token)input.LT(1);
            	    if ( (input.LA(1)>=INITIAL && input.LA(1)<=ERROR) ) {
            	        input.consume();
            	        adaptor.addChild(root_0, (CommonTree)adaptor.create(m));
            	        state.errorRecovery=false;
            	    }
            	    else {
            	        MismatchedSetException mse = new MismatchedSetException(null,input);
            	        throw mse;
            	    }

            	     EMarkType mt = token2markType(m);
            	            listener.checkInitFinErrRedeclaration(mt,m);
            	          
            	    i1=(Token)match(input,IDN,FOLLOW_IDN_in_marking1416); 
            	    i1_tree = (CommonTree)adaptor.create(i1);
            	    adaptor.addChild(root_0, i1_tree);

            	     listener.markAdd(mt, i1); 
            	    // NTS.g:457:7: ( COMMA i2= IDN )*
            	    loop15:
            	    do {
            	        int alt15=2;
            	        int LA15_0 = input.LA(1);

            	        if ( (LA15_0==COMMA) ) {
            	            alt15=1;
            	        }


            	        switch (alt15) {
            	    	case 1 :
            	    	    // NTS.g:457:8: COMMA i2= IDN
            	    	    {
            	    	    COMMA48=(Token)match(input,COMMA,FOLLOW_COMMA_in_marking1428); 
            	    	    COMMA48_tree = (CommonTree)adaptor.create(COMMA48);
            	    	    adaptor.addChild(root_0, COMMA48_tree);

            	    	    i2=(Token)match(input,IDN,FOLLOW_IDN_in_marking1432); 
            	    	    i2_tree = (CommonTree)adaptor.create(i2);
            	    	    adaptor.addChild(root_0, i2_tree);

            	    	     listener.markAdd(mt, i2); 

            	    	    }
            	    	    break;

            	    	default :
            	    	    break loop15;
            	        }
            	    } while (true);

            	    semi=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_marking1461); 
            	    semi_tree = (CommonTree)adaptor.create(semi);
            	    adaptor.addChild(root_0, semi_tree);


            	    }
            	    break;

            	default :
            	    if ( cnt16 >= 1 ) break loop16;
                        EarlyExitException eee =
                            new EarlyExitException(16, input);
                        throw eee;
                }
                cnt16++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "marking"

    public static class declar_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "declar"
    // NTS.g:471:1: declar : modif_annot declar_m_a ;
    public final NTSParser.declar_return declar() throws RecognitionException {
        NTSParser.declar_return retval = new NTSParser.declar_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.modif_annot_return modif_annot49 = null;

        NTSParser.declar_m_a_return declar_m_a50 = null;



        try {
            // NTS.g:472:3: ( modif_annot declar_m_a )
            // NTS.g:472:5: modif_annot declar_m_a
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_modif_annot_in_declar1488);
            modif_annot49=modif_annot();

            state._fsp--;

            adaptor.addChild(root_0, modif_annot49.getTree());
            pushFollow(FOLLOW_declar_m_a_in_declar1490);
            declar_m_a50=declar_m_a();

            state._fsp--;

            adaptor.addChild(root_0, declar_m_a50.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "declar"

    public static class declar_m_a_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "declar_m_a"
    // NTS.g:475:1: declar_m_a : ( dline_annot modif_annot )+ ;
    public final NTSParser.declar_m_a_return declar_m_a() throws RecognitionException {
        NTSParser.declar_m_a_return retval = new NTSParser.declar_m_a_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.dline_annot_return dline_annot51 = null;

        NTSParser.modif_annot_return modif_annot52 = null;



        try {
            // NTS.g:476:3: ( ( dline_annot modif_annot )+ )
            // NTS.g:476:5: ( dline_annot modif_annot )+
            {
            root_0 = (CommonTree)adaptor.nil();

            // NTS.g:476:5: ( dline_annot modif_annot )+
            int cnt17=0;
            loop17:
            do {
                int alt17=2;
                alt17 = dfa17.predict(input);
                switch (alt17) {
            	case 1 :
            	    // NTS.g:476:7: dline_annot modif_annot
            	    {
            	    pushFollow(FOLLOW_dline_annot_in_declar_m_a1505);
            	    dline_annot51=dline_annot();

            	    state._fsp--;

            	    adaptor.addChild(root_0, dline_annot51.getTree());
            	    pushFollow(FOLLOW_modif_annot_in_declar_m_a1507);
            	    modif_annot52=modif_annot();

            	    state._fsp--;

            	    adaptor.addChild(root_0, modif_annot52.getTree());

            	    }
            	    break;

            	default :
            	    if ( cnt17 >= 1 ) break loop17;
                        EarlyExitException eee =
                            new EarlyExitException(17, input);
                        throw eee;
                }
                cnt17++;
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "declar_m_a"

    public static class modif_annot_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modif_annot"
    // NTS.g:479:1: modif_annot : modifier annotations ;
    public final NTSParser.modif_annot_return modif_annot() throws RecognitionException {
        NTSParser.modif_annot_return retval = new NTSParser.modif_annot_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.modifier_return modifier53 = null;

        NTSParser.annotations_return annotations54 = null;



        try {
            // NTS.g:480:3: ( modifier annotations )
            // NTS.g:480:5: modifier annotations
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_modifier_in_modif_annot1523);
            modifier53=modifier();

            state._fsp--;

            adaptor.addChild(root_0, modifier53.getTree());
            pushFollow(FOLLOW_annotations_in_modif_annot1525);
            annotations54=annotations();

            state._fsp--;

            adaptor.addChild(root_0, annotations54.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modif_annot"

    public static class modifier_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "modifier"
    // NTS.g:483:1: modifier : (t= ( PARAM | IN | OUT ) | );
    public final NTSParser.modifier_return modifier() throws RecognitionException {
        NTSParser.modifier_return retval = new NTSParser.modifier_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token t=null;

        CommonTree t_tree=null;

        try {
            // NTS.g:484:3: (t= ( PARAM | IN | OUT ) | )
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( ((LA18_0>=PARAM && LA18_0<=OUT)) ) {
                alt18=1;
            }
            else if ( (LA18_0==IDN||LA18_0==AT||(LA18_0>=STATES && LA18_0<=INSTANCES)||LA18_0==RELATION) ) {
                alt18=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 18, 0, input);

                throw nvae;
            }
            switch (alt18) {
                case 1 :
                    // NTS.g:484:5: t= ( PARAM | IN | OUT )
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    t=(Token)input.LT(1);
                    if ( (input.LA(1)>=PARAM && input.LA(1)<=OUT) ) {
                        input.consume();
                        adaptor.addChild(root_0, (CommonTree)adaptor.create(t));
                        state.errorRecovery=false;
                    }
                    else {
                        MismatchedSetException mse = new MismatchedSetException(null,input);
                        throw mse;
                    }

                     listener.setModifier(t, token2modifier(t)); 

                    }
                    break;
                case 2 :
                    // NTS.g:485:5: 
                    {
                    root_0 = (CommonTree)adaptor.nil();

                     listener.setModifierNo(); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "modifier"

    public static class dline_annot_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dline_annot"
    // NTS.g:488:1: dline_annot : dblock_annot ( COMMA dblock )* SEMICOLON ;
    public final NTSParser.dline_annot_return dline_annot() throws RecognitionException {
        NTSParser.dline_annot_return retval = new NTSParser.dline_annot_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA56=null;
        Token SEMICOLON58=null;
        NTSParser.dblock_annot_return dblock_annot55 = null;

        NTSParser.dblock_return dblock57 = null;


        CommonTree COMMA56_tree=null;
        CommonTree SEMICOLON58_tree=null;

        try {
            // NTS.g:489:3: ( dblock_annot ( COMMA dblock )* SEMICOLON )
            // NTS.g:489:5: dblock_annot ( COMMA dblock )* SEMICOLON
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_dblock_annot_in_dline_annot1571);
            dblock_annot55=dblock_annot();

            state._fsp--;

            adaptor.addChild(root_0, dblock_annot55.getTree());
            // NTS.g:489:18: ( COMMA dblock )*
            loop19:
            do {
                int alt19=2;
                int LA19_0 = input.LA(1);

                if ( (LA19_0==COMMA) ) {
                    alt19=1;
                }


                switch (alt19) {
            	case 1 :
            	    // NTS.g:489:20: COMMA dblock
            	    {
            	    COMMA56=(Token)match(input,COMMA,FOLLOW_COMMA_in_dline_annot1575); 
            	    COMMA56_tree = (CommonTree)adaptor.create(COMMA56);
            	    adaptor.addChild(root_0, COMMA56_tree);

            	    pushFollow(FOLLOW_dblock_in_dline_annot1577);
            	    dblock57=dblock();

            	    state._fsp--;

            	    adaptor.addChild(root_0, dblock57.getTree());

            	    }
            	    break;

            	default :
            	    break loop19;
                }
            } while (true);

            SEMICOLON58=(Token)match(input,SEMICOLON,FOLLOW_SEMICOLON_in_dline_annot1582); 
            SEMICOLON58_tree = (CommonTree)adaptor.create(SEMICOLON58);
            adaptor.addChild(root_0, SEMICOLON58_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dline_annot"

    public static class dblock_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dblock"
    // NTS.g:492:1: dblock : annotations dblock_annot ;
    public final NTSParser.dblock_return dblock() throws RecognitionException {
        NTSParser.dblock_return retval = new NTSParser.dblock_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.annotations_return annotations59 = null;

        NTSParser.dblock_annot_return dblock_annot60 = null;



        try {
            // NTS.g:493:3: ( annotations dblock_annot )
            // NTS.g:493:5: annotations dblock_annot
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_annotations_in_dblock1595);
            annotations59=annotations();

            state._fsp--;

            adaptor.addChild(root_0, annotations59.getTree());
            pushFollow(FOLLOW_dblock_annot_in_dblock1597);
            dblock_annot60=dblock_annot();

            state._fsp--;

            adaptor.addChild(root_0, dblock_annot60.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dblock"

    public static class dblock_annot_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dblock_annot"
    // NTS.g:496:1: dblock_annot : dvar_annot ( COMMA dvar )* COLON basic_type ;
    public final NTSParser.dblock_annot_return dblock_annot() throws RecognitionException {
        NTSParser.dblock_annot_return retval = new NTSParser.dblock_annot_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA62=null;
        Token COLON64=null;
        NTSParser.dvar_annot_return dvar_annot61 = null;

        NTSParser.dvar_return dvar63 = null;

        NTSParser.basic_type_return basic_type65 = null;


        CommonTree COMMA62_tree=null;
        CommonTree COLON64_tree=null;

        try {
            // NTS.g:497:3: ( dvar_annot ( COMMA dvar )* COLON basic_type )
            // NTS.g:497:5: dvar_annot ( COMMA dvar )* COLON basic_type
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_dvar_annot_in_dblock_annot1610);
            dvar_annot61=dvar_annot();

            state._fsp--;

            adaptor.addChild(root_0, dvar_annot61.getTree());
            // NTS.g:497:16: ( COMMA dvar )*
            loop20:
            do {
                int alt20=2;
                int LA20_0 = input.LA(1);

                if ( (LA20_0==COMMA) ) {
                    alt20=1;
                }


                switch (alt20) {
            	case 1 :
            	    // NTS.g:497:17: COMMA dvar
            	    {
            	    COMMA62=(Token)match(input,COMMA,FOLLOW_COMMA_in_dblock_annot1613); 
            	    COMMA62_tree = (CommonTree)adaptor.create(COMMA62);
            	    adaptor.addChild(root_0, COMMA62_tree);

            	    pushFollow(FOLLOW_dvar_in_dblock_annot1615);
            	    dvar63=dvar();

            	    state._fsp--;

            	    adaptor.addChild(root_0, dvar63.getTree());

            	    }
            	    break;

            	default :
            	    break loop20;
                }
            } while (true);

            COLON64=(Token)match(input,COLON,FOLLOW_COLON_in_dblock_annot1620); 
            COLON64_tree = (CommonTree)adaptor.create(COLON64);
            adaptor.addChild(root_0, COLON64_tree);

            pushFollow(FOLLOW_basic_type_in_dblock_annot1622);
            basic_type65=basic_type();

            state._fsp--;

            adaptor.addChild(root_0, basic_type65.getTree());
             listener.declarationSetBasicType((basic_type65!=null?basic_type65.rT:null)); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dblock_annot"

    public static class dvar_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dvar"
    // NTS.g:501:1: dvar : annotations dvar_annot ;
    public final NTSParser.dvar_return dvar() throws RecognitionException {
        NTSParser.dvar_return retval = new NTSParser.dvar_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.annotations_return annotations66 = null;

        NTSParser.dvar_annot_return dvar_annot67 = null;



        try {
            // NTS.g:502:3: ( annotations dvar_annot )
            // NTS.g:502:5: annotations dvar_annot
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_annotations_in_dvar1641);
            annotations66=annotations();

            state._fsp--;

            adaptor.addChild(root_0, annotations66.getTree());
            pushFollow(FOLLOW_dvar_annot_in_dvar1643);
            dvar_annot67=dvar_annot();

            state._fsp--;

            adaptor.addChild(root_0, dvar_annot67.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dvar"

    public static class dvar_annot_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "dvar_annot"
    // NTS.g:505:1: dvar_annot : name= IDN ( LPAR_S ( expr )? RPAR_S )* ;
    public final NTSParser.dvar_annot_return dvar_annot() throws RecognitionException {
        NTSParser.dvar_annot_return retval = new NTSParser.dvar_annot_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token name=null;
        Token LPAR_S68=null;
        Token RPAR_S70=null;
        NTSParser.expr_return expr69 = null;


        CommonTree name_tree=null;
        CommonTree LPAR_S68_tree=null;
        CommonTree RPAR_S70_tree=null;

        try {
            // NTS.g:506:3: (name= IDN ( LPAR_S ( expr )? RPAR_S )* )
            // NTS.g:506:5: name= IDN ( LPAR_S ( expr )? RPAR_S )*
            {
            root_0 = (CommonTree)adaptor.nil();

             int s=0; // 0=(basic type), 1=(pure array reference), 2=(not pure array reference);  0-initial, 0->1, 0->2 OK 
                  int x=0; // total dimension
                  int y=0; // own dimension
                
            name=(Token)match(input,IDN,FOLLOW_IDN_in_dvar_annot1664); 
            name_tree = (CommonTree)adaptor.create(name);
            adaptor.addChild(root_0, name_tree);

            // NTS.g:511:5: ( LPAR_S ( expr )? RPAR_S )*
            loop22:
            do {
                int alt22=2;
                int LA22_0 = input.LA(1);

                if ( (LA22_0==LPAR_S) ) {
                    alt22=1;
                }


                switch (alt22) {
            	case 1 :
            	    // NTS.g:511:7: LPAR_S ( expr )? RPAR_S
            	    {
            	    LPAR_S68=(Token)match(input,LPAR_S,FOLLOW_LPAR_S_in_dvar_annot1672); 
            	    LPAR_S68_tree = (CommonTree)adaptor.create(LPAR_S68);
            	    adaptor.addChild(root_0, LPAR_S68_tree);

            	     x++; 
            	    // NTS.g:513:7: ( expr )?
            	    int alt21=2;
            	    alt21 = dfa21.predict(input);
            	    switch (alt21) {
            	        case 1 :
            	            // NTS.g:513:9: expr
            	            {
            	            pushFollow(FOLLOW_expr_in_dvar_annot1691);
            	            expr69=expr();

            	            state._fsp--;

            	            adaptor.addChild(root_0, expr69.getTree());
            	             if (s==1) {
            	                        System.err.println("Syntax error at "+Common.at(name)+". Reference to array of specific sizes is not a valid type.");
            	                        System.exit(1);
            	                      }
            	                      if (s==0) s=2;
            	                      y++;
            	                    

            	            }
            	            break;

            	    }

            	     if (s==0) s=1; 
            	    RPAR_S70=(Token)match(input,RPAR_S,FOLLOW_RPAR_S_in_dvar_annot1728); 
            	    RPAR_S70_tree = (CommonTree)adaptor.create(RPAR_S70);
            	    adaptor.addChild(root_0, RPAR_S70_tree);


            	    }
            	    break;

            	default :
            	    break loop22;
                }
            } while (true);

             listener.declarationAdd(name,y,x); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "dvar_annot"

    public static class basic_type_return extends ParserRuleReturnScope {
        public EBasicType rT;
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "basic_type"
    // NTS.g:528:1: basic_type returns [EBasicType rT] : t= ( TBOOL | TINT | TREAL ) ;
    public final NTSParser.basic_type_return basic_type() throws RecognitionException {
        NTSParser.basic_type_return retval = new NTSParser.basic_type_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token t=null;

        CommonTree t_tree=null;

        try {
            // NTS.g:529:3: (t= ( TBOOL | TINT | TREAL ) )
            // NTS.g:529:5: t= ( TBOOL | TINT | TREAL )
            {
            root_0 = (CommonTree)adaptor.nil();

            t=(Token)input.LT(1);
            if ( (input.LA(1)>=TBOOL && input.LA(1)<=TREAL) ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(t));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }

             retval.rT = token2basicType(t); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "basic_type"

    public static class qdecl_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qdecl"
    // NTS.g:537:1: qdecl : qd_block ( COMMA qd_block )* DOT ;
    public final NTSParser.qdecl_return qdecl() throws RecognitionException {
        NTSParser.qdecl_return retval = new NTSParser.qdecl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA72=null;
        Token DOT74=null;
        NTSParser.qd_block_return qd_block71 = null;

        NTSParser.qd_block_return qd_block73 = null;


        CommonTree COMMA72_tree=null;
        CommonTree DOT74_tree=null;

        try {
            // NTS.g:538:3: ( qd_block ( COMMA qd_block )* DOT )
            // NTS.g:538:5: qd_block ( COMMA qd_block )* DOT
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_qd_block_in_qdecl1790);
            qd_block71=qd_block();

            state._fsp--;

            adaptor.addChild(root_0, qd_block71.getTree());
            // NTS.g:538:14: ( COMMA qd_block )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==COMMA) ) {
                    alt23=1;
                }


                switch (alt23) {
            	case 1 :
            	    // NTS.g:538:16: COMMA qd_block
            	    {
            	    COMMA72=(Token)match(input,COMMA,FOLLOW_COMMA_in_qdecl1794); 
            	    COMMA72_tree = (CommonTree)adaptor.create(COMMA72);
            	    adaptor.addChild(root_0, COMMA72_tree);

            	    pushFollow(FOLLOW_qd_block_in_qdecl1796);
            	    qd_block73=qd_block();

            	    state._fsp--;

            	    adaptor.addChild(root_0, qd_block73.getTree());

            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);

            DOT74=(Token)match(input,DOT,FOLLOW_DOT_in_qdecl1801); 
            DOT74_tree = (CommonTree)adaptor.create(DOT74);
            adaptor.addChild(root_0, DOT74_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "qdecl"

    public static class qd_block_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qd_block"
    // NTS.g:541:1: qd_block : id1= IDN ( COMMA id2= IDN )* COLON qd_type ;
    public final NTSParser.qd_block_return qd_block() throws RecognitionException {
        NTSParser.qd_block_return retval = new NTSParser.qd_block_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token id1=null;
        Token id2=null;
        Token COMMA75=null;
        Token COLON76=null;
        NTSParser.qd_type_return qd_type77 = null;


        CommonTree id1_tree=null;
        CommonTree id2_tree=null;
        CommonTree COMMA75_tree=null;
        CommonTree COLON76_tree=null;

        try {
            // NTS.g:542:3: (id1= IDN ( COMMA id2= IDN )* COLON qd_type )
            // NTS.g:542:5: id1= IDN ( COMMA id2= IDN )* COLON qd_type
            {
            root_0 = (CommonTree)adaptor.nil();

            id1=(Token)match(input,IDN,FOLLOW_IDN_in_qd_block1816); 
            id1_tree = (CommonTree)adaptor.create(id1);
            adaptor.addChild(root_0, id1_tree);

             listener.declarationQ(id1); 
            // NTS.g:543:5: ( COMMA id2= IDN )*
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==COMMA) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // NTS.g:543:7: COMMA id2= IDN
            	    {
            	    COMMA75=(Token)match(input,COMMA,FOLLOW_COMMA_in_qd_block1827); 
            	    COMMA75_tree = (CommonTree)adaptor.create(COMMA75);
            	    adaptor.addChild(root_0, COMMA75_tree);

            	    id2=(Token)match(input,IDN,FOLLOW_IDN_in_qd_block1831); 
            	    id2_tree = (CommonTree)adaptor.create(id2);
            	    adaptor.addChild(root_0, id2_tree);

            	     listener.declarationQ(id2); 

            	    }
            	    break;

            	default :
            	    break loop24;
                }
            } while (true);

            COLON76=(Token)match(input,COLON,FOLLOW_COLON_in_qd_block1843); 
            COLON76_tree = (CommonTree)adaptor.create(COLON76);
            adaptor.addChild(root_0, COLON76_tree);

            pushFollow(FOLLOW_qd_type_in_qd_block1845);
            qd_type77=qd_type();

            state._fsp--;

            adaptor.addChild(root_0, qd_type77.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "qd_block"

    public static class qd_type_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "qd_type"
    // NTS.g:547:1: qd_type : b= basic_type ( LPAR_S expr COMMA expr RPAR_S )? ;
    public final NTSParser.qd_type_return qd_type() throws RecognitionException {
        NTSParser.qd_type_return retval = new NTSParser.qd_type_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAR_S78=null;
        Token COMMA80=null;
        Token RPAR_S82=null;
        NTSParser.basic_type_return b = null;

        NTSParser.expr_return expr79 = null;

        NTSParser.expr_return expr81 = null;


        CommonTree LPAR_S78_tree=null;
        CommonTree COMMA80_tree=null;
        CommonTree RPAR_S82_tree=null;

        try {
            // NTS.g:548:3: (b= basic_type ( LPAR_S expr COMMA expr RPAR_S )? )
            // NTS.g:548:5: b= basic_type ( LPAR_S expr COMMA expr RPAR_S )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_basic_type_in_qd_type1860);
            b=basic_type();

            state._fsp--;

            adaptor.addChild(root_0, b.getTree());
            // NTS.g:549:5: ( LPAR_S expr COMMA expr RPAR_S )?
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==LPAR_S) ) {
                alt25=1;
            }
            switch (alt25) {
                case 1 :
                    // NTS.g:549:7: LPAR_S expr COMMA expr RPAR_S
                    {
                    LPAR_S78=(Token)match(input,LPAR_S,FOLLOW_LPAR_S_in_qd_type1868); 
                    LPAR_S78_tree = (CommonTree)adaptor.create(LPAR_S78);
                    adaptor.addChild(root_0, LPAR_S78_tree);

                    pushFollow(FOLLOW_expr_in_qd_type1870);
                    expr79=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr79.getTree());
                    COMMA80=(Token)match(input,COMMA,FOLLOW_COMMA_in_qd_type1872); 
                    COMMA80_tree = (CommonTree)adaptor.create(COMMA80);
                    adaptor.addChild(root_0, COMMA80_tree);

                    pushFollow(FOLLOW_expr_in_qd_type1874);
                    expr81=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr81.getTree());
                    RPAR_S82=(Token)match(input,RPAR_S,FOLLOW_RPAR_S_in_qd_type1876); 
                    RPAR_S82_tree = (CommonTree)adaptor.create(RPAR_S82);
                    adaptor.addChild(root_0, RPAR_S82_tree);


                    }
                    break;

            }

             listener.declarationQ((b!=null?b.rT:null), LPAR_S78); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "qd_type"

    public static class transition_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "transition"
    // NTS.g:557:1: transition : (id0= IDN COLON )? id1= IDN C_IMPL id2= IDN a= annotations LPAR_C l= label RPAR_C ;
    public final NTSParser.transition_return transition() throws RecognitionException {
        NTSParser.transition_return retval = new NTSParser.transition_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token id0=null;
        Token id1=null;
        Token id2=null;
        Token COLON83=null;
        Token C_IMPL84=null;
        Token LPAR_C85=null;
        Token RPAR_C86=null;
        NTSParser.annotations_return a = null;

        NTSParser.label_return l = null;


        CommonTree id0_tree=null;
        CommonTree id1_tree=null;
        CommonTree id2_tree=null;
        CommonTree COLON83_tree=null;
        CommonTree C_IMPL84_tree=null;
        CommonTree LPAR_C85_tree=null;
        CommonTree RPAR_C86_tree=null;

        try {
            // NTS.g:558:3: ( (id0= IDN COLON )? id1= IDN C_IMPL id2= IDN a= annotations LPAR_C l= label RPAR_C )
            // NTS.g:558:5: (id0= IDN COLON )? id1= IDN C_IMPL id2= IDN a= annotations LPAR_C l= label RPAR_C
            {
            root_0 = (CommonTree)adaptor.nil();

            // NTS.g:558:5: (id0= IDN COLON )?
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==IDN) ) {
                int LA26_1 = input.LA(2);

                if ( (LA26_1==COLON) ) {
                    alt26=1;
                }
            }
            switch (alt26) {
                case 1 :
                    // NTS.g:558:7: id0= IDN COLON
                    {
                    id0=(Token)match(input,IDN,FOLLOW_IDN_in_transition1906); 
                    id0_tree = (CommonTree)adaptor.create(id0);
                    adaptor.addChild(root_0, id0_tree);

                    COLON83=(Token)match(input,COLON,FOLLOW_COLON_in_transition1908); 
                    COLON83_tree = (CommonTree)adaptor.create(COLON83);
                    adaptor.addChild(root_0, COLON83_tree);


                    }
                    break;

            }

            id1=(Token)match(input,IDN,FOLLOW_IDN_in_transition1915); 
            id1_tree = (CommonTree)adaptor.create(id1);
            adaptor.addChild(root_0, id1_tree);

            C_IMPL84=(Token)match(input,C_IMPL,FOLLOW_C_IMPL_in_transition1917); 
            C_IMPL84_tree = (CommonTree)adaptor.create(C_IMPL84);
            adaptor.addChild(root_0, C_IMPL84_tree);

            id2=(Token)match(input,IDN,FOLLOW_IDN_in_transition1921); 
            id2_tree = (CommonTree)adaptor.create(id2);
            adaptor.addChild(root_0, id2_tree);

            pushFollow(FOLLOW_annotations_in_transition1925);
            a=annotations();

            state._fsp--;

            adaptor.addChild(root_0, a.getTree());
            LPAR_C85=(Token)match(input,LPAR_C,FOLLOW_LPAR_C_in_transition1927); 
            LPAR_C85_tree = (CommonTree)adaptor.create(LPAR_C85);
            adaptor.addChild(root_0, LPAR_C85_tree);

            pushFollow(FOLLOW_label_in_transition1931);
            l=label();

            state._fsp--;

            adaptor.addChild(root_0, l.getTree());
            RPAR_C86=(Token)match(input,RPAR_C,FOLLOW_RPAR_C_in_transition1933); 
            RPAR_C86_tree = (CommonTree)adaptor.create(RPAR_C86);
            adaptor.addChild(root_0, RPAR_C86_tree);

             listener.transition(id0,id1,id2,(l!=null?l.rL:null)); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "transition"

    public static class label_return extends ParserRuleReturnScope {
        public ILabel rL;
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "label"
    // NTS.g:561:1: label returns [ILabel rL] : ({...}? call_havoc | expr | );
    public final NTSParser.label_return label() throws RecognitionException {
        NTSParser.label_return retval = new NTSParser.label_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.call_havoc_return call_havoc87 = null;

        NTSParser.expr_return expr88 = null;



        try {
            // NTS.g:562:3: ({...}? call_havoc | expr | )
            int alt27=3;
            alt27 = dfa27.predict(input);
            switch (alt27) {
                case 1 :
                    // NTS.g:562:5: {...}? call_havoc
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    if ( !(( isCall() )) ) {
                        throw new FailedPredicateException(input, "label", " isCall() ");
                    }
                    pushFollow(FOLLOW_call_havoc_in_label1957);
                    call_havoc87=call_havoc();

                    state._fsp--;

                    adaptor.addChild(root_0, call_havoc87.getTree());
                     retval.rL = listener.labelCall(); 

                    }
                    break;
                case 2 :
                    // NTS.g:563:5: expr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_expr_in_label1965);
                    expr88=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr88.getTree());
                     retval.rL = listener.labelExpr(); 

                    }
                    break;
                case 3 :
                    // NTS.g:564:5: 
                    {
                    root_0 = (CommonTree)adaptor.nil();

                     retval.rL = listener.labelDummyTrue(dummyTrue()); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "label"

    public static class call_havoc_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "call_havoc"
    // NTS.g:571:1: call_havoc : call ( op_and havoc )? ;
    public final NTSParser.call_havoc_return call_havoc() throws RecognitionException {
        NTSParser.call_havoc_return retval = new NTSParser.call_havoc_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.call_return call89 = null;

        NTSParser.op_and_return op_and90 = null;

        NTSParser.havoc_return havoc91 = null;



        try {
            // NTS.g:572:3: ( call ( op_and havoc )? )
            // NTS.g:572:5: call ( op_and havoc )?
            {
            root_0 = (CommonTree)adaptor.nil();

             listener.callInit(); 
            pushFollow(FOLLOW_call_in_call_havoc1996);
            call89=call();

            state._fsp--;

            adaptor.addChild(root_0, call89.getTree());
            // NTS.g:574:5: ( op_and havoc )?
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==AND||LA28_0==C_AND) ) {
                alt28=1;
            }
            switch (alt28) {
                case 1 :
                    // NTS.g:574:6: op_and havoc
                    {
                    pushFollow(FOLLOW_op_and_in_call_havoc2003);
                    op_and90=op_and();

                    state._fsp--;

                    adaptor.addChild(root_0, op_and90.getTree());
                    pushFollow(FOLLOW_havoc_in_call_havoc2005);
                    havoc91=havoc();

                    state._fsp--;

                    adaptor.addChild(root_0, havoc91.getTree());
                     listener.callHavoc(); 

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "call_havoc"

    public static class call_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "call"
    // NTS.g:578:1: call : ( ret_idp EQ call2[ECallArg.ACT] | call2[ECallArg.ACTRET] | LPAR retlist RPAR EQ call2[ECallArg.ACT] );
    public final NTSParser.call_return call() throws RecognitionException {
        NTSParser.call_return retval = new NTSParser.call_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token EQ93=null;
        Token LPAR96=null;
        Token RPAR98=null;
        Token EQ99=null;
        NTSParser.ret_idp_return ret_idp92 = null;

        NTSParser.call2_return call294 = null;

        NTSParser.call2_return call295 = null;

        NTSParser.retlist_return retlist97 = null;

        NTSParser.call2_return call2100 = null;


        CommonTree EQ93_tree=null;
        CommonTree LPAR96_tree=null;
        CommonTree RPAR98_tree=null;
        CommonTree EQ99_tree=null;

        try {
            // NTS.g:579:3: ( ret_idp EQ call2[ECallArg.ACT] | call2[ECallArg.ACTRET] | LPAR retlist RPAR EQ call2[ECallArg.ACT] )
            int alt29=3;
            switch ( input.LA(1) ) {
            case IDP:
                {
                alt29=1;
                }
                break;
            case IDN:
                {
                alt29=2;
                }
                break;
            case LPAR:
                {
                alt29=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 29, 0, input);

                throw nvae;
            }

            switch (alt29) {
                case 1 :
                    // NTS.g:579:5: ret_idp EQ call2[ECallArg.ACT]
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_ret_idp_in_call2032);
                    ret_idp92=ret_idp();

                    state._fsp--;

                    adaptor.addChild(root_0, ret_idp92.getTree());
                    EQ93=(Token)match(input,EQ,FOLLOW_EQ_in_call2038); 
                    EQ93_tree = (CommonTree)adaptor.create(EQ93);
                    adaptor.addChild(root_0, EQ93_tree);

                    pushFollow(FOLLOW_call2_in_call2040);
                    call294=call2(ECallArg.ACT);

                    state._fsp--;

                    adaptor.addChild(root_0, call294.getTree());

                    }
                    break;
                case 2 :
                    // NTS.g:581:5: call2[ECallArg.ACTRET]
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_call2_in_call2047);
                    call295=call2(ECallArg.ACTRET);

                    state._fsp--;

                    adaptor.addChild(root_0, call295.getTree());

                    }
                    break;
                case 3 :
                    // NTS.g:582:5: LPAR retlist RPAR EQ call2[ECallArg.ACT]
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    LPAR96=(Token)match(input,LPAR,FOLLOW_LPAR_in_call2054); 
                    LPAR96_tree = (CommonTree)adaptor.create(LPAR96);
                    adaptor.addChild(root_0, LPAR96_tree);

                    pushFollow(FOLLOW_retlist_in_call2056);
                    retlist97=retlist();

                    state._fsp--;

                    adaptor.addChild(root_0, retlist97.getTree());
                    RPAR98=(Token)match(input,RPAR,FOLLOW_RPAR_in_call2058); 
                    RPAR98_tree = (CommonTree)adaptor.create(RPAR98);
                    adaptor.addChild(root_0, RPAR98_tree);

                    EQ99=(Token)match(input,EQ,FOLLOW_EQ_in_call2060); 
                    EQ99_tree = (CommonTree)adaptor.create(EQ99);
                    adaptor.addChild(root_0, EQ99_tree);

                    pushFollow(FOLLOW_call2_in_call2062);
                    call2100=call2(ECallArg.ACT);

                    state._fsp--;

                    adaptor.addChild(root_0, call2100.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "call"

    public static class call2_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "call2"
    // NTS.g:584:1: call2[ECallArg code] : IDN LPAR ( expr ( COMMA expr )* )? RPAR ;
    public final NTSParser.call2_return call2(ECallArg code) throws RecognitionException {
        NTSParser.call2_return retval = new NTSParser.call2_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IDN101=null;
        Token LPAR102=null;
        Token COMMA104=null;
        Token RPAR106=null;
        NTSParser.expr_return expr103 = null;

        NTSParser.expr_return expr105 = null;


        CommonTree IDN101_tree=null;
        CommonTree LPAR102_tree=null;
        CommonTree COMMA104_tree=null;
        CommonTree RPAR106_tree=null;

        try {
            // NTS.g:585:3: ( IDN LPAR ( expr ( COMMA expr )* )? RPAR )
            // NTS.g:585:5: IDN LPAR ( expr ( COMMA expr )* )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            IDN101=(Token)match(input,IDN,FOLLOW_IDN_in_call22076); 
            IDN101_tree = (CommonTree)adaptor.create(IDN101);
            adaptor.addChild(root_0, IDN101_tree);

             listener.callSetCallee(IDN101); 
            LPAR102=(Token)match(input,LPAR,FOLLOW_LPAR_in_call22084); 
            LPAR102_tree = (CommonTree)adaptor.create(LPAR102);
            adaptor.addChild(root_0, LPAR102_tree);

            // NTS.g:587:5: ( expr ( COMMA expr )* )?
            int alt31=2;
            alt31 = dfa31.predict(input);
            switch (alt31) {
                case 1 :
                    // NTS.g:587:7: expr ( COMMA expr )*
                    {
                    pushFollow(FOLLOW_expr_in_call22092);
                    expr103=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr103.getTree());
                     listener.callAddArgRet(code); 
                    // NTS.g:588:7: ( COMMA expr )*
                    loop30:
                    do {
                        int alt30=2;
                        int LA30_0 = input.LA(1);

                        if ( (LA30_0==COMMA) ) {
                            alt30=1;
                        }


                        switch (alt30) {
                    	case 1 :
                    	    // NTS.g:588:9: COMMA expr
                    	    {
                    	    COMMA104=(Token)match(input,COMMA,FOLLOW_COMMA_in_call22105); 
                    	    COMMA104_tree = (CommonTree)adaptor.create(COMMA104);
                    	    adaptor.addChild(root_0, COMMA104_tree);

                    	    pushFollow(FOLLOW_expr_in_call22107);
                    	    expr105=expr();

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, expr105.getTree());
                    	     listener.callAddArgRet(code); 

                    	    }
                    	    break;

                    	default :
                    	    break loop30;
                        }
                    } while (true);


                    }
                    break;

            }

            RPAR106=(Token)match(input,RPAR,FOLLOW_RPAR_in_call22129); 
            RPAR106_tree = (CommonTree)adaptor.create(RPAR106);
            adaptor.addChild(root_0, RPAR106_tree);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "call2"

    public static class retlist_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "retlist"
    // NTS.g:592:1: retlist : ret_idp ( COMMA ret_idp )* ;
    public final NTSParser.retlist_return retlist() throws RecognitionException {
        NTSParser.retlist_return retval = new NTSParser.retlist_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token COMMA108=null;
        NTSParser.ret_idp_return ret_idp107 = null;

        NTSParser.ret_idp_return ret_idp109 = null;


        CommonTree COMMA108_tree=null;

        try {
            // NTS.g:593:3: ( ret_idp ( COMMA ret_idp )* )
            // NTS.g:593:5: ret_idp ( COMMA ret_idp )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_ret_idp_in_retlist2141);
            ret_idp107=ret_idp();

            state._fsp--;

            adaptor.addChild(root_0, ret_idp107.getTree());
            // NTS.g:593:13: ( COMMA ret_idp )*
            loop32:
            do {
                int alt32=2;
                int LA32_0 = input.LA(1);

                if ( (LA32_0==COMMA) ) {
                    alt32=1;
                }


                switch (alt32) {
            	case 1 :
            	    // NTS.g:593:15: COMMA ret_idp
            	    {
            	    COMMA108=(Token)match(input,COMMA,FOLLOW_COMMA_in_retlist2145); 
            	    COMMA108_tree = (CommonTree)adaptor.create(COMMA108);
            	    adaptor.addChild(root_0, COMMA108_tree);

            	    pushFollow(FOLLOW_ret_idp_in_retlist2147);
            	    ret_idp109=ret_idp();

            	    state._fsp--;

            	    adaptor.addChild(root_0, ret_idp109.getTree());

            	    }
            	    break;

            	default :
            	    break loop32;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "retlist"

    public static class ret_idp_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "ret_idp"
    // NTS.g:595:1: ret_idp : IDP ;
    public final NTSParser.ret_idp_return ret_idp() throws RecognitionException {
        NTSParser.ret_idp_return retval = new NTSParser.ret_idp_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token IDP110=null;

        CommonTree IDP110_tree=null;

        try {
            // NTS.g:596:3: ( IDP )
            // NTS.g:596:5: IDP
            {
            root_0 = (CommonTree)adaptor.nil();

            IDP110=(Token)match(input,IDP,FOLLOW_IDP_in_ret_idp2162); 
            IDP110_tree = (CommonTree)adaptor.create(IDP110);
            adaptor.addChild(root_0, IDP110_tree);

             listener.access(IDP110,0,0);
                  listener.callAddArgRet(ECallArg.RET);
                

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "ret_idp"

    public static class expr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "expr"
    // NTS.g:606:1: expr : equiv ;
    public final NTSParser.expr_return expr() throws RecognitionException {
        NTSParser.expr_return retval = new NTSParser.expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.equiv_return equiv111 = null;



        try {
            // NTS.g:607:3: ( equiv )
            // NTS.g:607:5: equiv
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_equiv_in_expr2186);
            equiv111=equiv();

            state._fsp--;

            adaptor.addChild(root_0, equiv111.getTree());

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "expr"

    public static class equiv_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "equiv"
    // NTS.g:609:1: equiv : impl (op= op_equiv impl )* ;
    public final NTSParser.equiv_return equiv() throws RecognitionException {
        NTSParser.equiv_return retval = new NTSParser.equiv_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.op_equiv_return op = null;

        NTSParser.impl_return impl112 = null;

        NTSParser.impl_return impl113 = null;



        try {
            // NTS.g:610:3: ( impl (op= op_equiv impl )* )
            // NTS.g:610:5: impl (op= op_equiv impl )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_impl_in_equiv2198);
            impl112=impl();

            state._fsp--;

            adaptor.addChild(root_0, impl112.getTree());
            // NTS.g:610:10: (op= op_equiv impl )*
            loop33:
            do {
                int alt33=2;
                int LA33_0 = input.LA(1);

                if ( (LA33_0==EQUIV||LA33_0==C_EQUIV) ) {
                    alt33=1;
                }


                switch (alt33) {
            	case 1 :
            	    // NTS.g:610:12: op= op_equiv impl
            	    {
            	    pushFollow(FOLLOW_op_equiv_in_equiv2204);
            	    op=op_equiv();

            	    state._fsp--;

            	    adaptor.addChild(root_0, op.getTree());
            	    pushFollow(FOLLOW_impl_in_equiv2206);
            	    impl113=impl();

            	    state._fsp--;

            	    adaptor.addChild(root_0, impl113.getTree());
            	     listener.equiv((op!=null?((Token)op.start):null)); 

            	    }
            	    break;

            	default :
            	    break loop33;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "equiv"

    public static class impl_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "impl"
    // NTS.g:612:1: impl : or (op= op_impl or )* ;
    public final NTSParser.impl_return impl() throws RecognitionException {
        NTSParser.impl_return retval = new NTSParser.impl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.op_impl_return op = null;

        NTSParser.or_return or114 = null;

        NTSParser.or_return or115 = null;



        try {
            // NTS.g:613:3: ( or (op= op_impl or )* )
            // NTS.g:613:5: or (op= op_impl or )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_or_in_impl2223);
            or114=or();

            state._fsp--;

            adaptor.addChild(root_0, or114.getTree());
            // NTS.g:613:8: (op= op_impl or )*
            loop34:
            do {
                int alt34=2;
                int LA34_0 = input.LA(1);

                if ( (LA34_0==IMPL||LA34_0==C_IMPL) ) {
                    alt34=1;
                }


                switch (alt34) {
            	case 1 :
            	    // NTS.g:613:10: op= op_impl or
            	    {
            	    pushFollow(FOLLOW_op_impl_in_impl2229);
            	    op=op_impl();

            	    state._fsp--;

            	    adaptor.addChild(root_0, op.getTree());
            	    pushFollow(FOLLOW_or_in_impl2231);
            	    or115=or();

            	    state._fsp--;

            	    adaptor.addChild(root_0, or115.getTree());
            	     listener.impl((op!=null?((Token)op.start):null)); 

            	    }
            	    break;

            	default :
            	    break loop34;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "impl"

    public static class or_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "or"
    // NTS.g:615:1: or : and (op= op_or and )* ;
    public final NTSParser.or_return or() throws RecognitionException {
        NTSParser.or_return retval = new NTSParser.or_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.op_or_return op = null;

        NTSParser.and_return and116 = null;

        NTSParser.and_return and117 = null;



        try {
            // NTS.g:616:3: ( and (op= op_or and )* )
            // NTS.g:616:5: and (op= op_or and )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_and_in_or2248);
            and116=and();

            state._fsp--;

            adaptor.addChild(root_0, and116.getTree());
            // NTS.g:616:9: (op= op_or and )*
            loop35:
            do {
                int alt35=2;
                int LA35_0 = input.LA(1);

                if ( (LA35_0==OR||LA35_0==C_OR) ) {
                    alt35=1;
                }


                switch (alt35) {
            	case 1 :
            	    // NTS.g:616:11: op= op_or and
            	    {
            	    pushFollow(FOLLOW_op_or_in_or2254);
            	    op=op_or();

            	    state._fsp--;

            	    adaptor.addChild(root_0, op.getTree());
            	    pushFollow(FOLLOW_and_in_or2256);
            	    and117=and();

            	    state._fsp--;

            	    adaptor.addChild(root_0, and117.getTree());
            	     listener.or((op!=null?((Token)op.start):null)); 

            	    }
            	    break;

            	default :
            	    break loop35;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "or"

    public static class and_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "and"
    // NTS.g:618:1: and : not (op= op_and not )* ;
    public final NTSParser.and_return and() throws RecognitionException {
        NTSParser.and_return retval = new NTSParser.and_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.op_and_return op = null;

        NTSParser.not_return not118 = null;

        NTSParser.not_return not119 = null;



        try {
            // NTS.g:619:3: ( not (op= op_and not )* )
            // NTS.g:619:5: not (op= op_and not )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_not_in_and2273);
            not118=not();

            state._fsp--;

            adaptor.addChild(root_0, not118.getTree());
            // NTS.g:619:9: (op= op_and not )*
            loop36:
            do {
                int alt36=2;
                alt36 = dfa36.predict(input);
                switch (alt36) {
            	case 1 :
            	    // NTS.g:619:11: op= op_and not
            	    {
            	    pushFollow(FOLLOW_op_and_in_and2279);
            	    op=op_and();

            	    state._fsp--;

            	    adaptor.addChild(root_0, op.getTree());
            	    pushFollow(FOLLOW_not_in_and2281);
            	    not119=not();

            	    state._fsp--;

            	    adaptor.addChild(root_0, not119.getTree());
            	     listener.and((op!=null?((Token)op.start):null)); 

            	    }
            	    break;

            	default :
            	    break loop36;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "and"

    public static class not_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "not"
    // NTS.g:621:1: not : (op= op_not )* predicate ;
    public final NTSParser.not_return not() throws RecognitionException {
        NTSParser.not_return retval = new NTSParser.not_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.op_not_return op = null;

        NTSParser.predicate_return predicate120 = null;



        try {
            // NTS.g:622:3: ( (op= op_not )* predicate )
            // NTS.g:622:5: (op= op_not )* predicate
            {
            root_0 = (CommonTree)adaptor.nil();

             int n = 0; 
            // NTS.g:623:5: (op= op_not )*
            loop37:
            do {
                int alt37=2;
                alt37 = dfa37.predict(input);
                switch (alt37) {
            	case 1 :
            	    // NTS.g:623:6: op= op_not
            	    {
            	    pushFollow(FOLLOW_op_not_in_not2307);
            	    op=op_not();

            	    state._fsp--;

            	    adaptor.addChild(root_0, op.getTree());
            	    n++;

            	    }
            	    break;

            	default :
            	    break loop37;
                }
            } while (true);

            pushFollow(FOLLOW_predicate_in_not2314);
            predicate120=predicate();

            state._fsp--;

            adaptor.addChild(root_0, predicate120.getTree());
             if ((n%2 == 1))
                     listener.not((op!=null?((Token)op.start):null));
                

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "not"

    public static class predicate_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "predicate"
    // NTS.g:629:1: predicate : ( havoc | quant | pred_rop );
    public final NTSParser.predicate_return predicate() throws RecognitionException {
        NTSParser.predicate_return retval = new NTSParser.predicate_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.havoc_return havoc121 = null;

        NTSParser.quant_return quant122 = null;

        NTSParser.pred_rop_return pred_rop123 = null;



        try {
            // NTS.g:630:3: ( havoc | quant | pred_rop )
            int alt38=3;
            alt38 = dfa38.predict(input);
            switch (alt38) {
                case 1 :
                    // NTS.g:630:5: havoc
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_havoc_in_predicate2333);
                    havoc121=havoc();

                    state._fsp--;

                    adaptor.addChild(root_0, havoc121.getTree());

                    }
                    break;
                case 2 :
                    // NTS.g:631:5: quant
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_quant_in_predicate2339);
                    quant122=quant();

                    state._fsp--;

                    adaptor.addChild(root_0, quant122.getTree());

                    }
                    break;
                case 3 :
                    // NTS.g:632:5: pred_rop
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_pred_rop_in_predicate2346);
                    pred_rop123=pred_rop();

                    state._fsp--;

                    adaptor.addChild(root_0, pred_rop123.getTree());

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "predicate"

    public static class pred_rop_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "pred_rop"
    // NTS.g:634:1: pred_rop : plusminus (op= rop plusminus )? ;
    public final NTSParser.pred_rop_return pred_rop() throws RecognitionException {
        NTSParser.pred_rop_return retval = new NTSParser.pred_rop_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.rop_return op = null;

        NTSParser.plusminus_return plusminus124 = null;

        NTSParser.plusminus_return plusminus125 = null;



        try {
            // NTS.g:635:3: ( plusminus (op= rop plusminus )? )
            // NTS.g:635:5: plusminus (op= rop plusminus )?
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_plusminus_in_pred_rop2358);
            plusminus124=plusminus();

            state._fsp--;

            adaptor.addChild(root_0, plusminus124.getTree());
            // NTS.g:636:5: (op= rop plusminus )?
            int alt39=2;
            alt39 = dfa39.predict(input);
            switch (alt39) {
                case 1 :
                    // NTS.g:636:7: op= rop plusminus
                    {
                    pushFollow(FOLLOW_rop_in_pred_rop2368);
                    op=rop();

                    state._fsp--;

                    adaptor.addChild(root_0, op.getTree());
                    pushFollow(FOLLOW_plusminus_in_pred_rop2370);
                    plusminus125=plusminus();

                    state._fsp--;

                    adaptor.addChild(root_0, plusminus125.getTree());
                     Token tok = (op!=null?((Token)op.start):null);
                            switch(tok.getType()) {
                              case EQ: listener.eq(tok); break;
                              case NEQ: listener.neq(tok); break;
                              case LEQ: listener.leq(tok); break;
                              case LT: listener.lt(tok); break;
                              case GEQ: listener.geq(tok); break;
                              case GT: listener.gt(tok); break;
                              default: throw new RuntimeException("internal error");
                            }
                          

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "pred_rop"

    public static class quant_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "quant"
    // NTS.g:651:1: quant : qq= quantifier qdecl predicate ;
    public final NTSParser.quant_return quant() throws RecognitionException {
        NTSParser.quant_return retval = new NTSParser.quant_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.quantifier_return qq = null;

        NTSParser.qdecl_return qdecl126 = null;

        NTSParser.predicate_return predicate127 = null;



        try {
            // NTS.g:652:3: (qq= quantifier qdecl predicate )
            // NTS.g:652:5: qq= quantifier qdecl predicate
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_quantifier_in_quant2401);
            qq=quantifier();

            state._fsp--;

            adaptor.addChild(root_0, qq.getTree());
             Token tok = (qq!=null?((Token)qq.start):null);
                  int tt = tok.getType();
                  listener.quantifierInit(tok, (tt == EXISTS));
                
            pushFollow(FOLLOW_qdecl_in_quant2418);
            qdecl126=qdecl();

            state._fsp--;

            adaptor.addChild(root_0, qdecl126.getTree());
            pushFollow(FOLLOW_predicate_in_quant2428);
            predicate127=predicate();

            state._fsp--;

            adaptor.addChild(root_0, predicate127.getTree());
             listener.quantifierFinalize(); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "quant"

    public static class plusminus_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "plusminus"
    // NTS.g:663:1: plusminus : mult_div_rem (op= pm mult_div_rem )* ;
    public final NTSParser.plusminus_return plusminus() throws RecognitionException {
        NTSParser.plusminus_return retval = new NTSParser.plusminus_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.pm_return op = null;

        NTSParser.mult_div_rem_return mult_div_rem128 = null;

        NTSParser.mult_div_rem_return mult_div_rem129 = null;



        try {
            // NTS.g:664:3: ( mult_div_rem (op= pm mult_div_rem )* )
            // NTS.g:664:5: mult_div_rem (op= pm mult_div_rem )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_mult_div_rem_in_plusminus2451);
            mult_div_rem128=mult_div_rem();

            state._fsp--;

            adaptor.addChild(root_0, mult_div_rem128.getTree());
            // NTS.g:665:5: (op= pm mult_div_rem )*
            loop40:
            do {
                int alt40=2;
                alt40 = dfa40.predict(input);
                switch (alt40) {
            	case 1 :
            	    // NTS.g:665:7: op= pm mult_div_rem
            	    {
            	    pushFollow(FOLLOW_pm_in_plusminus2462);
            	    op=pm();

            	    state._fsp--;

            	    adaptor.addChild(root_0, op.getTree());
            	    pushFollow(FOLLOW_mult_div_rem_in_plusminus2464);
            	    mult_div_rem129=mult_div_rem();

            	    state._fsp--;

            	    adaptor.addChild(root_0, mult_div_rem129.getTree());
            	     Token tok = (op!=null?((Token)op.start):null);
            	            switch(tok.getType()) {
            	              case PLUS: listener.plus(tok); break;
            	              case MINUS: listener.minus(tok); break;
            	              default: throw new RuntimeException("internal error");
            	            }
            	          

            	    }
            	    break;

            	default :
            	    break loop40;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "plusminus"

    public static class mult_div_rem_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "mult_div_rem"
    // NTS.g:675:1: mult_div_rem : un_plusminus (op= mdr un_plusminus )* ;
    public final NTSParser.mult_div_rem_return mult_div_rem() throws RecognitionException {
        NTSParser.mult_div_rem_return retval = new NTSParser.mult_div_rem_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        NTSParser.mdr_return op = null;

        NTSParser.un_plusminus_return un_plusminus130 = null;

        NTSParser.un_plusminus_return un_plusminus131 = null;



        try {
            // NTS.g:676:3: ( un_plusminus (op= mdr un_plusminus )* )
            // NTS.g:676:5: un_plusminus (op= mdr un_plusminus )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_un_plusminus_in_mult_div_rem2492);
            un_plusminus130=un_plusminus();

            state._fsp--;

            adaptor.addChild(root_0, un_plusminus130.getTree());
            // NTS.g:677:5: (op= mdr un_plusminus )*
            loop41:
            do {
                int alt41=2;
                alt41 = dfa41.predict(input);
                switch (alt41) {
            	case 1 :
            	    // NTS.g:677:7: op= mdr un_plusminus
            	    {
            	    pushFollow(FOLLOW_mdr_in_mult_div_rem2503);
            	    op=mdr();

            	    state._fsp--;

            	    adaptor.addChild(root_0, op.getTree());
            	    pushFollow(FOLLOW_un_plusminus_in_mult_div_rem2505);
            	    un_plusminus131=un_plusminus();

            	    state._fsp--;

            	    adaptor.addChild(root_0, un_plusminus131.getTree());
            	     Token tok = (op!=null?((Token)op.start):null);
            	            switch(tok.getType()) {
            	              case MULT: listener.mult(tok); break;
            	              case DIVIDE: listener.divide(tok); break;
            	              case REMAINDER: listener.remainder(tok); break;
            	              default: throw new RuntimeException("internal error");
            	            }
            	          

            	    }
            	    break;

            	default :
            	    break loop41;
                }
            } while (true);


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "mult_div_rem"

    public static class un_plusminus_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "un_plusminus"
    // NTS.g:688:1: un_plusminus : (m= MINUS )? atom ;
    public final NTSParser.un_plusminus_return un_plusminus() throws RecognitionException {
        NTSParser.un_plusminus_return retval = new NTSParser.un_plusminus_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token m=null;
        NTSParser.atom_return atom132 = null;


        CommonTree m_tree=null;

        try {
            // NTS.g:689:3: ( (m= MINUS )? atom )
            // NTS.g:689:5: (m= MINUS )? atom
            {
            root_0 = (CommonTree)adaptor.nil();

            // NTS.g:689:5: (m= MINUS )?
            int alt42=2;
            alt42 = dfa42.predict(input);
            switch (alt42) {
                case 1 :
                    // NTS.g:689:6: m= MINUS
                    {
                    m=(Token)match(input,MINUS,FOLLOW_MINUS_in_un_plusminus2536); 
                    m_tree = (CommonTree)adaptor.create(m);
                    adaptor.addChild(root_0, m_tree);


                    }
                    break;

            }

            pushFollow(FOLLOW_atom_in_un_plusminus2540);
            atom132=atom();

            state._fsp--;

            adaptor.addChild(root_0, atom132.getTree());
             if (m != null) listener.unaryMinus(m); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "un_plusminus"

    public static class atom_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "atom"
    // NTS.g:692:1: atom : ( access | literal | many_expr | arrsize | LPAR expr RPAR );
    public final NTSParser.atom_return atom() throws RecognitionException {
        NTSParser.atom_return retval = new NTSParser.atom_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAR137=null;
        Token RPAR139=null;
        NTSParser.access_return access133 = null;

        NTSParser.literal_return literal134 = null;

        NTSParser.many_expr_return many_expr135 = null;

        NTSParser.arrsize_return arrsize136 = null;

        NTSParser.expr_return expr138 = null;


        CommonTree LPAR137_tree=null;
        CommonTree RPAR139_tree=null;

        try {
            // NTS.g:693:3: ( access | literal | many_expr | arrsize | LPAR expr RPAR )
            int alt43=5;
            switch ( input.LA(1) ) {
            case IDN:
            case IDP:
            case TID:
                {
                alt43=1;
                }
                break;
            case LITINT:
            case LITREAL:
            case TRUE:
            case FALSE:
                {
                alt43=2;
                }
                break;
            case LPAR_S:
                {
                alt43=3;
                }
                break;
            case VBAR:
                {
                alt43=4;
                }
                break;
            case LPAR:
                {
                alt43=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 43, 0, input);

                throw nvae;
            }

            switch (alt43) {
                case 1 :
                    // NTS.g:693:5: access
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_access_in_atom2558);
                    access133=access();

                    state._fsp--;

                    adaptor.addChild(root_0, access133.getTree());

                    }
                    break;
                case 2 :
                    // NTS.g:694:5: literal
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_literal_in_atom2564);
                    literal134=literal();

                    state._fsp--;

                    adaptor.addChild(root_0, literal134.getTree());

                    }
                    break;
                case 3 :
                    // NTS.g:695:5: many_expr
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_many_expr_in_atom2570);
                    many_expr135=many_expr();

                    state._fsp--;

                    adaptor.addChild(root_0, many_expr135.getTree());

                    }
                    break;
                case 4 :
                    // NTS.g:696:5: arrsize
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_arrsize_in_atom2576);
                    arrsize136=arrsize();

                    state._fsp--;

                    adaptor.addChild(root_0, arrsize136.getTree());

                    }
                    break;
                case 5 :
                    // NTS.g:697:5: LPAR expr RPAR
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    LPAR137=(Token)match(input,LPAR,FOLLOW_LPAR_in_atom2582); 
                    LPAR137_tree = (CommonTree)adaptor.create(LPAR137);
                    adaptor.addChild(root_0, LPAR137_tree);

                    pushFollow(FOLLOW_expr_in_atom2584);
                    expr138=expr();

                    state._fsp--;

                    adaptor.addChild(root_0, expr138.getTree());
                    RPAR139=(Token)match(input,RPAR,FOLLOW_RPAR_in_atom2586); 
                    RPAR139_tree = (CommonTree)adaptor.create(RPAR139);
                    adaptor.addChild(root_0, RPAR139_tree);


                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "atom"

    public static class many_expr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "many_expr"
    // NTS.g:701:1: many_expr : LPAR_S e1= expr ( COMMA e2= expr )* RPAR_S ;
    public final NTSParser.many_expr_return many_expr() throws RecognitionException {
        NTSParser.many_expr_return retval = new NTSParser.many_expr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAR_S140=null;
        Token COMMA141=null;
        Token RPAR_S142=null;
        NTSParser.expr_return e1 = null;

        NTSParser.expr_return e2 = null;


        CommonTree LPAR_S140_tree=null;
        CommonTree COMMA141_tree=null;
        CommonTree RPAR_S142_tree=null;

        try {
            // NTS.g:702:3: ( LPAR_S e1= expr ( COMMA e2= expr )* RPAR_S )
            // NTS.g:702:5: LPAR_S e1= expr ( COMMA e2= expr )* RPAR_S
            {
            root_0 = (CommonTree)adaptor.nil();

             int n = 0; 
            LPAR_S140=(Token)match(input,LPAR_S,FOLLOW_LPAR_S_in_many_expr2606); 
            LPAR_S140_tree = (CommonTree)adaptor.create(LPAR_S140);
            adaptor.addChild(root_0, LPAR_S140_tree);

            pushFollow(FOLLOW_expr_in_many_expr2616);
            e1=expr();

            state._fsp--;

            adaptor.addChild(root_0, e1.getTree());
             n++; 
            // NTS.g:705:7: ( COMMA e2= expr )*
            loop44:
            do {
                int alt44=2;
                int LA44_0 = input.LA(1);

                if ( (LA44_0==COMMA) ) {
                    alt44=1;
                }


                switch (alt44) {
            	case 1 :
            	    // NTS.g:705:9: COMMA e2= expr
            	    {
            	    COMMA141=(Token)match(input,COMMA,FOLLOW_COMMA_in_many_expr2628); 
            	    COMMA141_tree = (CommonTree)adaptor.create(COMMA141);
            	    adaptor.addChild(root_0, COMMA141_tree);

            	    pushFollow(FOLLOW_expr_in_many_expr2632);
            	    e2=expr();

            	    state._fsp--;

            	    adaptor.addChild(root_0, e2.getTree());
            	     n++; 

            	    }
            	    break;

            	default :
            	    break loop44;
                }
            } while (true);

            RPAR_S142=(Token)match(input,RPAR_S,FOLLOW_RPAR_S_in_many_expr2643); 
            RPAR_S142_tree = (CommonTree)adaptor.create(RPAR_S142);
            adaptor.addChild(root_0, RPAR_S142_tree);

             listener.exprList(LPAR_S140,n); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "many_expr"

    public static class arrsize_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "arrsize"
    // NTS.g:711:1: arrsize : v1= VBAR access VBAR ;
    public final NTSParser.arrsize_return arrsize() throws RecognitionException {
        NTSParser.arrsize_return retval = new NTSParser.arrsize_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token v1=null;
        Token VBAR144=null;
        NTSParser.access_return access143 = null;


        CommonTree v1_tree=null;
        CommonTree VBAR144_tree=null;

        try {
            // NTS.g:712:3: (v1= VBAR access VBAR )
            // NTS.g:712:5: v1= VBAR access VBAR
            {
            root_0 = (CommonTree)adaptor.nil();

            v1=(Token)match(input,VBAR,FOLLOW_VBAR_in_arrsize2669); 
            v1_tree = (CommonTree)adaptor.create(v1);
            adaptor.addChild(root_0, v1_tree);

             v1.setType(ARR_LENGTH); 
            pushFollow(FOLLOW_access_in_arrsize2678);
            access143=access();

            state._fsp--;

            adaptor.addChild(root_0, access143.getTree());
            VBAR144=(Token)match(input,VBAR,FOLLOW_VBAR_in_arrsize2680); 
            VBAR144_tree = (CommonTree)adaptor.create(VBAR144);
            adaptor.addChild(root_0, VBAR144_tree);

             listener.arraySize(v1); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "arrsize"

    public static class access_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "access"
    // NTS.g:720:1: access : id ( LPAR_S e1= expr ( COMMA expr )* RPAR_S )* ;
    public final NTSParser.access_return access() throws RecognitionException {
        NTSParser.access_return retval = new NTSParser.access_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token LPAR_S146=null;
        Token COMMA147=null;
        Token RPAR_S149=null;
        NTSParser.expr_return e1 = null;

        NTSParser.id_return id145 = null;

        NTSParser.expr_return expr148 = null;


        CommonTree LPAR_S146_tree=null;
        CommonTree COMMA147_tree=null;
        CommonTree RPAR_S149_tree=null;

        try {
            // NTS.g:721:3: ( id ( LPAR_S e1= expr ( COMMA expr )* RPAR_S )* )
            // NTS.g:721:5: id ( LPAR_S e1= expr ( COMMA expr )* RPAR_S )*
            {
            root_0 = (CommonTree)adaptor.nil();

            pushFollow(FOLLOW_id_in_access2702);
            id145=id();

            state._fsp--;

            adaptor.addChild(root_0, id145.getTree());
             int m = 0, s = 0; 
            // NTS.g:725:5: ( LPAR_S e1= expr ( COMMA expr )* RPAR_S )*
            loop46:
            do {
                int alt46=2;
                alt46 = dfa46.predict(input);
                switch (alt46) {
            	case 1 :
            	    // NTS.g:727:7: LPAR_S e1= expr ( COMMA expr )* RPAR_S
            	    {
            	     if (m != 0) {
            	              System.err.println("Syntax error near "+Common.at((e1!=null?((Token)e1.start):null))+": multi-access cannot be followed by another access.");
            	              System.exit(1);
            	            }
            	          
            	    LPAR_S146=(Token)match(input,LPAR_S,FOLLOW_LPAR_S_in_access2761); 
            	    LPAR_S146_tree = (CommonTree)adaptor.create(LPAR_S146);
            	    adaptor.addChild(root_0, LPAR_S146_tree);

            	    pushFollow(FOLLOW_expr_in_access2765);
            	    e1=expr();

            	    state._fsp--;

            	    adaptor.addChild(root_0, e1.getTree());
            	     m++; 
            	    // NTS.g:735:7: ( COMMA expr )*
            	    loop45:
            	    do {
            	        int alt45=2;
            	        int LA45_0 = input.LA(1);

            	        if ( (LA45_0==COMMA) ) {
            	            alt45=1;
            	        }


            	        switch (alt45) {
            	    	case 1 :
            	    	    // NTS.g:735:9: COMMA expr
            	    	    {
            	    	    COMMA147=(Token)match(input,COMMA,FOLLOW_COMMA_in_access2777); 
            	    	    COMMA147_tree = (CommonTree)adaptor.create(COMMA147);
            	    	    adaptor.addChild(root_0, COMMA147_tree);

            	    	    pushFollow(FOLLOW_expr_in_access2779);
            	    	    expr148=expr();

            	    	    state._fsp--;

            	    	    adaptor.addChild(root_0, expr148.getTree());
            	    	     m++; 

            	    	    }
            	    	    break;

            	    	default :
            	    	    break loop45;
            	        }
            	    } while (true);

            	    RPAR_S149=(Token)match(input,RPAR_S,FOLLOW_RPAR_S_in_access2792); 
            	    RPAR_S149_tree = (CommonTree)adaptor.create(RPAR_S149);
            	    adaptor.addChild(root_0, RPAR_S149_tree);

            	     if (m == 1) {
            	              s += m; m = 0;
            	            }
            	          

            	    }
            	    break;

            	default :
            	    break loop46;
                }
            } while (true);

             listener.access((id145!=null?((Token)id145.start):null),s,m); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "access"

    public static class havoc_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "havoc"
    // NTS.g:749:1: havoc : HAVOC LPAR (id1= IDN ( COMMA id2= IDN )* )? RPAR ;
    public final NTSParser.havoc_return havoc() throws RecognitionException {
        NTSParser.havoc_return retval = new NTSParser.havoc_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token id1=null;
        Token id2=null;
        Token HAVOC150=null;
        Token LPAR151=null;
        Token COMMA152=null;
        Token RPAR153=null;

        CommonTree id1_tree=null;
        CommonTree id2_tree=null;
        CommonTree HAVOC150_tree=null;
        CommonTree LPAR151_tree=null;
        CommonTree COMMA152_tree=null;
        CommonTree RPAR153_tree=null;

        try {
            // NTS.g:750:3: ( HAVOC LPAR (id1= IDN ( COMMA id2= IDN )* )? RPAR )
            // NTS.g:750:5: HAVOC LPAR (id1= IDN ( COMMA id2= IDN )* )? RPAR
            {
            root_0 = (CommonTree)adaptor.nil();

            HAVOC150=(Token)match(input,HAVOC,FOLLOW_HAVOC_in_havoc2847); 
            HAVOC150_tree = (CommonTree)adaptor.create(HAVOC150);
            adaptor.addChild(root_0, HAVOC150_tree);

            LPAR151=(Token)match(input,LPAR,FOLLOW_LPAR_in_havoc2849); 
            LPAR151_tree = (CommonTree)adaptor.create(LPAR151);
            adaptor.addChild(root_0, LPAR151_tree);

             List<Token> l = new LinkedList<Token>(); 
            // NTS.g:753:5: (id1= IDN ( COMMA id2= IDN )* )?
            int alt48=2;
            int LA48_0 = input.LA(1);

            if ( (LA48_0==IDN) ) {
                alt48=1;
            }
            switch (alt48) {
                case 1 :
                    // NTS.g:753:6: id1= IDN ( COMMA id2= IDN )*
                    {
                    id1=(Token)match(input,IDN,FOLLOW_IDN_in_havoc2869); 
                    id1_tree = (CommonTree)adaptor.create(id1);
                    adaptor.addChild(root_0, id1_tree);

                     l.add(id1); 
                    // NTS.g:754:7: ( COMMA id2= IDN )*
                    loop47:
                    do {
                        int alt47=2;
                        int LA47_0 = input.LA(1);

                        if ( (LA47_0==COMMA) ) {
                            alt47=1;
                        }


                        switch (alt47) {
                    	case 1 :
                    	    // NTS.g:754:8: COMMA id2= IDN
                    	    {
                    	    COMMA152=(Token)match(input,COMMA,FOLLOW_COMMA_in_havoc2881); 
                    	    COMMA152_tree = (CommonTree)adaptor.create(COMMA152);
                    	    adaptor.addChild(root_0, COMMA152_tree);

                    	    id2=(Token)match(input,IDN,FOLLOW_IDN_in_havoc2885); 
                    	    id2_tree = (CommonTree)adaptor.create(id2);
                    	    adaptor.addChild(root_0, id2_tree);

                    	     l.add(id2); 

                    	    }
                    	    break;

                    	default :
                    	    break loop47;
                        }
                    } while (true);


                    }
                    break;

            }

            RPAR153=(Token)match(input,RPAR,FOLLOW_RPAR_in_havoc2910); 
            RPAR153_tree = (CommonTree)adaptor.create(RPAR153);
            adaptor.addChild(root_0, RPAR153_tree);

             listener.havoc(HAVOC150, l); 

            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "havoc"

    public static class id_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "id"
    // NTS.g:762:1: id : ( IDN | IDP | TID );
    public final NTSParser.id_return id() throws RecognitionException {
        NTSParser.id_return retval = new NTSParser.id_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set154=null;

        CommonTree set154_tree=null;

        try {
            // NTS.g:763:3: ( IDN | IDP | TID )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set154=(Token)input.LT(1);
            if ( (input.LA(1)>=IDN && input.LA(1)<=IDP)||input.LA(1)==TID ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set154));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "id"

    public static class literal_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "literal"
    // NTS.g:767:1: literal : ( boollit | li= LITINT | lr= LITREAL );
    public final NTSParser.literal_return literal() throws RecognitionException {
        NTSParser.literal_return retval = new NTSParser.literal_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token li=null;
        Token lr=null;
        NTSParser.boollit_return boollit155 = null;


        CommonTree li_tree=null;
        CommonTree lr_tree=null;

        try {
            // NTS.g:768:3: ( boollit | li= LITINT | lr= LITREAL )
            int alt49=3;
            switch ( input.LA(1) ) {
            case TRUE:
            case FALSE:
                {
                alt49=1;
                }
                break;
            case LITINT:
                {
                alt49=2;
                }
                break;
            case LITREAL:
                {
                alt49=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 49, 0, input);

                throw nvae;
            }

            switch (alt49) {
                case 1 :
                    // NTS.g:768:5: boollit
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    pushFollow(FOLLOW_boollit_in_literal2958);
                    boollit155=boollit();

                    state._fsp--;

                    adaptor.addChild(root_0, boollit155.getTree());

                    }
                    break;
                case 2 :
                    // NTS.g:769:5: li= LITINT
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    li=(Token)match(input,LITINT,FOLLOW_LITINT_in_literal2966); 
                    li_tree = (CommonTree)adaptor.create(li);
                    adaptor.addChild(root_0, li_tree);

                     listener.litInt(li); 

                    }
                    break;
                case 3 :
                    // NTS.g:770:5: lr= LITREAL
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    lr=(Token)match(input,LITREAL,FOLLOW_LITREAL_in_literal2976); 
                    lr_tree = (CommonTree)adaptor.create(lr);
                    adaptor.addChild(root_0, lr_tree);

                     listener.litReal(lr); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "literal"

    public static class boollit_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "boollit"
    // NTS.g:772:1: boollit : ( TRUE | FALSE );
    public final NTSParser.boollit_return boollit() throws RecognitionException {
        NTSParser.boollit_return retval = new NTSParser.boollit_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token TRUE156=null;
        Token FALSE157=null;

        CommonTree TRUE156_tree=null;
        CommonTree FALSE157_tree=null;

        try {
            // NTS.g:773:3: ( TRUE | FALSE )
            int alt50=2;
            int LA50_0 = input.LA(1);

            if ( (LA50_0==TRUE) ) {
                alt50=1;
            }
            else if ( (LA50_0==FALSE) ) {
                alt50=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 50, 0, input);

                throw nvae;
            }
            switch (alt50) {
                case 1 :
                    // NTS.g:773:5: TRUE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    TRUE156=(Token)match(input,TRUE,FOLLOW_TRUE_in_boollit2990); 
                    TRUE156_tree = (CommonTree)adaptor.create(TRUE156);
                    adaptor.addChild(root_0, TRUE156_tree);

                     listener.litTrue(TRUE156); 

                    }
                    break;
                case 2 :
                    // NTS.g:774:5: FALSE
                    {
                    root_0 = (CommonTree)adaptor.nil();

                    FALSE157=(Token)match(input,FALSE,FOLLOW_FALSE_in_boollit2998); 
                    FALSE157_tree = (CommonTree)adaptor.create(FALSE157);
                    adaptor.addChild(root_0, FALSE157_tree);

                     listener.litFalse(FALSE157); 

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "boollit"

    public static class pm_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "pm"
    // NTS.g:776:1: pm : ( PLUS | MINUS );
    public final NTSParser.pm_return pm() throws RecognitionException {
        NTSParser.pm_return retval = new NTSParser.pm_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set158=null;

        CommonTree set158_tree=null;

        try {
            // NTS.g:777:3: ( PLUS | MINUS )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set158=(Token)input.LT(1);
            if ( (input.LA(1)>=PLUS && input.LA(1)<=MINUS) ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set158));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "pm"

    public static class mdr_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "mdr"
    // NTS.g:780:1: mdr : ( MULT | DIVIDE | REMAINDER );
    public final NTSParser.mdr_return mdr() throws RecognitionException {
        NTSParser.mdr_return retval = new NTSParser.mdr_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set159=null;

        CommonTree set159_tree=null;

        try {
            // NTS.g:781:3: ( MULT | DIVIDE | REMAINDER )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set159=(Token)input.LT(1);
            if ( (input.LA(1)>=MULT && input.LA(1)<=REMAINDER) ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set159));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "mdr"

    public static class rop_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "rop"
    // NTS.g:785:1: rop : ( EQ | NEQ | LEQ | LT | GEQ | GT );
    public final NTSParser.rop_return rop() throws RecognitionException {
        NTSParser.rop_return retval = new NTSParser.rop_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set160=null;

        CommonTree set160_tree=null;

        try {
            // NTS.g:786:3: ( EQ | NEQ | LEQ | LT | GEQ | GT )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set160=(Token)input.LT(1);
            if ( (input.LA(1)>=EQ && input.LA(1)<=GT) ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set160));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "rop"

    public static class quantifier_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "quantifier"
    // NTS.g:793:1: quantifier : ( EXISTS | FORALL );
    public final NTSParser.quantifier_return quantifier() throws RecognitionException {
        NTSParser.quantifier_return retval = new NTSParser.quantifier_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set161=null;

        CommonTree set161_tree=null;

        try {
            // NTS.g:794:3: ( EXISTS | FORALL )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set161=(Token)input.LT(1);
            if ( (input.LA(1)>=EXISTS && input.LA(1)<=FORALL) ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set161));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "quantifier"

    public static class op_equiv_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "op_equiv"
    // NTS.g:797:1: op_equiv : ( EQUIV | C_EQUIV );
    public final NTSParser.op_equiv_return op_equiv() throws RecognitionException {
        NTSParser.op_equiv_return retval = new NTSParser.op_equiv_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set162=null;

        CommonTree set162_tree=null;

        try {
            // NTS.g:798:3: ( EQUIV | C_EQUIV )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set162=(Token)input.LT(1);
            if ( input.LA(1)==EQUIV||input.LA(1)==C_EQUIV ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set162));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "op_equiv"

    public static class op_impl_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "op_impl"
    // NTS.g:800:1: op_impl : ( IMPL | C_IMPL );
    public final NTSParser.op_impl_return op_impl() throws RecognitionException {
        NTSParser.op_impl_return retval = new NTSParser.op_impl_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set163=null;

        CommonTree set163_tree=null;

        try {
            // NTS.g:801:3: ( IMPL | C_IMPL )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set163=(Token)input.LT(1);
            if ( input.LA(1)==IMPL||input.LA(1)==C_IMPL ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set163));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "op_impl"

    public static class op_or_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "op_or"
    // NTS.g:803:1: op_or : ( OR | C_OR );
    public final NTSParser.op_or_return op_or() throws RecognitionException {
        NTSParser.op_or_return retval = new NTSParser.op_or_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set164=null;

        CommonTree set164_tree=null;

        try {
            // NTS.g:804:3: ( OR | C_OR )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set164=(Token)input.LT(1);
            if ( input.LA(1)==OR||input.LA(1)==C_OR ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set164));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "op_or"

    public static class op_and_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "op_and"
    // NTS.g:806:1: op_and : ( AND | C_AND );
    public final NTSParser.op_and_return op_and() throws RecognitionException {
        NTSParser.op_and_return retval = new NTSParser.op_and_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set165=null;

        CommonTree set165_tree=null;

        try {
            // NTS.g:807:3: ( AND | C_AND )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set165=(Token)input.LT(1);
            if ( input.LA(1)==AND||input.LA(1)==C_AND ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set165));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "op_and"

    public static class op_not_return extends ParserRuleReturnScope {
        CommonTree tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "op_not"
    // NTS.g:809:1: op_not : ( NOT | C_NOT );
    public final NTSParser.op_not_return op_not() throws RecognitionException {
        NTSParser.op_not_return retval = new NTSParser.op_not_return();
        retval.start = input.LT(1);

        CommonTree root_0 = null;

        Token set166=null;

        CommonTree set166_tree=null;

        try {
            // NTS.g:810:3: ( NOT | C_NOT )
            // NTS.g:
            {
            root_0 = (CommonTree)adaptor.nil();

            set166=(Token)input.LT(1);
            if ( input.LA(1)==NOT||input.LA(1)==C_NOT ) {
                input.consume();
                adaptor.addChild(root_0, (CommonTree)adaptor.create(set166));
                state.errorRecovery=false;
            }
            else {
                MismatchedSetException mse = new MismatchedSetException(null,input);
                throw mse;
            }


            }

            retval.stop = input.LT(-1);

            retval.tree = (CommonTree)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }

          catch (RecognitionException ex) {
            reportError(ex);
            System.exit(1);
          }
        finally {
        }
        return retval;
    }
    // $ANTLR end "op_not"

    // Delegated rules


    protected DFA1 dfa1 = new DFA1(this);
    protected DFA8 dfa8 = new DFA8(this);
    protected DFA7 dfa7 = new DFA7(this);
    protected DFA9 dfa9 = new DFA9(this);
    protected DFA10 dfa10 = new DFA10(this);
    protected DFA17 dfa17 = new DFA17(this);
    protected DFA21 dfa21 = new DFA21(this);
    protected DFA27 dfa27 = new DFA27(this);
    protected DFA31 dfa31 = new DFA31(this);
    protected DFA36 dfa36 = new DFA36(this);
    protected DFA37 dfa37 = new DFA37(this);
    protected DFA38 dfa38 = new DFA38(this);
    protected DFA39 dfa39 = new DFA39(this);
    protected DFA40 dfa40 = new DFA40(this);
    protected DFA41 dfa41 = new DFA41(this);
    protected DFA42 dfa42 = new DFA42(this);
    protected DFA46 dfa46 = new DFA46(this);
    static final String DFA1_eotS =
        "\16\uffff";
    static final String DFA1_eofS =
        "\1\1\15\uffff";
    static final String DFA1_minS =
        "\1\4\15\uffff";
    static final String DFA1_maxS =
        "\1\77\15\uffff";
    static final String DFA1_acceptS =
        "\1\uffff\1\2\1\1\13\uffff";
    static final String DFA1_specialS =
        "\16\uffff}>";
    static final String[] DFA1_transitionS = {
            "\4\2\4\uffff\3\2\4\uffff\1\2\4\uffff\2\2\6\uffff\1\2\1\uffff"+
            "\1\2\3\uffff\1\2\1\uffff\1\2\25\uffff\2\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA1_eot = DFA.unpackEncodedString(DFA1_eotS);
    static final short[] DFA1_eof = DFA.unpackEncodedString(DFA1_eofS);
    static final char[] DFA1_min = DFA.unpackEncodedStringToUnsignedChars(DFA1_minS);
    static final char[] DFA1_max = DFA.unpackEncodedStringToUnsignedChars(DFA1_maxS);
    static final short[] DFA1_accept = DFA.unpackEncodedString(DFA1_acceptS);
    static final short[] DFA1_special = DFA.unpackEncodedString(DFA1_specialS);
    static final short[][] DFA1_transition;

    static {
        int numStates = DFA1_transitionS.length;
        DFA1_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA1_transition[i] = DFA.unpackEncodedString(DFA1_transitionS[i]);
        }
    }

    class DFA1 extends DFA {

        public DFA1(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 1;
            this.eot = DFA1_eot;
            this.eof = DFA1_eof;
            this.min = DFA1_min;
            this.max = DFA1_max;
            this.accept = DFA1_accept;
            this.special = DFA1_special;
            this.transition = DFA1_transition;
        }
        public String getDescription() {
            return "()+ loopback of 336:21: ( expr SEMICOLON )+";
        }
    }
    static final String DFA8_eotS =
        "\12\uffff";
    static final String DFA8_eofS =
        "\12\uffff";
    static final String DFA8_minS =
        "\1\4\11\uffff";
    static final String DFA8_maxS =
        "\1\100\11\uffff";
    static final String DFA8_acceptS =
        "\1\uffff\1\1\1\2\7\uffff";
    static final String DFA8_specialS =
        "\12\uffff}>";
    static final String[] DFA8_transitionS = {
            "\1\2\4\uffff\1\2\1\1\37\uffff\1\2\15\uffff\6\2\2\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA8_eot = DFA.unpackEncodedString(DFA8_eotS);
    static final short[] DFA8_eof = DFA.unpackEncodedString(DFA8_eofS);
    static final char[] DFA8_min = DFA.unpackEncodedStringToUnsignedChars(DFA8_minS);
    static final char[] DFA8_max = DFA.unpackEncodedStringToUnsignedChars(DFA8_maxS);
    static final short[] DFA8_accept = DFA.unpackEncodedString(DFA8_acceptS);
    static final short[] DFA8_special = DFA.unpackEncodedString(DFA8_specialS);
    static final short[][] DFA8_transition;

    static {
        int numStates = DFA8_transitionS.length;
        DFA8_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA8_transition[i] = DFA.unpackEncodedString(DFA8_transitionS[i]);
        }
    }

    class DFA8 extends DFA {

        public DFA8(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 8;
            this.eot = DFA8_eot;
            this.eof = DFA8_eof;
            this.min = DFA8_min;
            this.max = DFA8_max;
            this.accept = DFA8_accept;
            this.special = DFA8_special;
            this.transition = DFA8_transition;
        }
        public String getDescription() {
            return "399:1: annotations : (a1= annotation ( annotation )* | );";
        }
    }
    static final String DFA7_eotS =
        "\12\uffff";
    static final String DFA7_eofS =
        "\12\uffff";
    static final String DFA7_minS =
        "\1\4\11\uffff";
    static final String DFA7_maxS =
        "\1\100\11\uffff";
    static final String DFA7_acceptS =
        "\1\uffff\1\2\7\uffff\1\1";
    static final String DFA7_specialS =
        "\12\uffff}>";
    static final String[] DFA7_transitionS = {
            "\1\1\4\uffff\1\1\1\11\37\uffff\1\1\15\uffff\6\1\2\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA7_eot = DFA.unpackEncodedString(DFA7_eotS);
    static final short[] DFA7_eof = DFA.unpackEncodedString(DFA7_eofS);
    static final char[] DFA7_min = DFA.unpackEncodedStringToUnsignedChars(DFA7_minS);
    static final char[] DFA7_max = DFA.unpackEncodedStringToUnsignedChars(DFA7_maxS);
    static final short[] DFA7_accept = DFA.unpackEncodedString(DFA7_acceptS);
    static final short[] DFA7_special = DFA.unpackEncodedString(DFA7_specialS);
    static final short[][] DFA7_transition;

    static {
        int numStates = DFA7_transitionS.length;
        DFA7_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA7_transition[i] = DFA.unpackEncodedString(DFA7_transitionS[i]);
        }
    }

    class DFA7 extends DFA {

        public DFA7(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 7;
            this.eot = DFA7_eot;
            this.eof = DFA7_eof;
            this.min = DFA7_min;
            this.max = DFA7_max;
            this.accept = DFA7_accept;
            this.special = DFA7_special;
            this.transition = DFA7_transition;
        }
        public String getDescription() {
            return "()* loopback of 402:5: ( annotation )*";
        }
    }
    static final String DFA9_eotS =
        "\16\uffff";
    static final String DFA9_eofS =
        "\16\uffff";
    static final String DFA9_minS =
        "\1\4\15\uffff";
    static final String DFA9_maxS =
        "\1\102\15\uffff";
    static final String DFA9_acceptS =
        "\1\uffff\1\1\1\2\13\uffff";
    static final String DFA9_specialS =
        "\16\uffff}>";
    static final String[] DFA9_transitionS = {
            "\4\2\4\uffff\3\2\4\uffff\1\2\4\uffff\2\2\6\uffff\1\2\1\uffff"+
            "\1\2\3\uffff\1\2\1\uffff\1\2\25\uffff\2\2\2\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA9_eot = DFA.unpackEncodedString(DFA9_eotS);
    static final short[] DFA9_eof = DFA.unpackEncodedString(DFA9_eofS);
    static final char[] DFA9_min = DFA.unpackEncodedStringToUnsignedChars(DFA9_minS);
    static final char[] DFA9_max = DFA.unpackEncodedStringToUnsignedChars(DFA9_maxS);
    static final short[] DFA9_accept = DFA.unpackEncodedString(DFA9_acceptS);
    static final short[] DFA9_special = DFA.unpackEncodedString(DFA9_specialS);
    static final short[][] DFA9_transition;

    static {
        int numStates = DFA9_transitionS.length;
        DFA9_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA9_transition[i] = DFA.unpackEncodedString(DFA9_transitionS[i]);
        }
    }

    class DFA9 extends DFA {

        public DFA9(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 9;
            this.eot = DFA9_eot;
            this.eof = DFA9_eof;
            this.min = DFA9_min;
            this.max = DFA9_max;
            this.accept = DFA9_accept;
            this.special = DFA9_special;
            this.transition = DFA9_transition;
        }
        public String getDescription() {
            return "411:1: annot_value[Token aKey, EAnnotType aT] : (s= litstring | e= expr );";
        }
    }
    static final String DFA10_eotS =
        "\14\uffff";
    static final String DFA10_eofS =
        "\14\uffff";
    static final String DFA10_minS =
        "\1\4\2\uffff\1\26\2\uffff\1\4\5\uffff";
    static final String DFA10_maxS =
        "\1\73\2\uffff\1\56\2\uffff\1\62\5\uffff";
    static final String DFA10_acceptS =
        "\1\uffff\1\1\2\uffff\1\2\7\uffff";
    static final String DFA10_specialS =
        "\14\uffff}>";
    static final String[] DFA10_transitionS = {
            "\1\3\5\uffff\1\1\52\uffff\3\1\4\4",
            "",
            "",
            "\1\4\21\uffff\1\1\4\uffff\1\1\1\6",
            "",
            "",
            "\1\4\53\uffff\3\1",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA10_eot = DFA.unpackEncodedString(DFA10_eotS);
    static final short[] DFA10_eof = DFA.unpackEncodedString(DFA10_eofS);
    static final char[] DFA10_min = DFA.unpackEncodedStringToUnsignedChars(DFA10_minS);
    static final char[] DFA10_max = DFA.unpackEncodedStringToUnsignedChars(DFA10_maxS);
    static final short[] DFA10_accept = DFA.unpackEncodedString(DFA10_acceptS);
    static final short[] DFA10_special = DFA.unpackEncodedString(DFA10_specialS);
    static final short[][] DFA10_transition;

    static {
        int numStates = DFA10_transitionS.length;
        DFA10_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA10_transition[i] = DFA.unpackEncodedString(DFA10_transitionS[i]);
        }
    }

    class DFA10 extends DFA {

        public DFA10(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 10;
            this.eot = DFA10_eot;
            this.eof = DFA10_eof;
            this.min = DFA10_min;
            this.max = DFA10_max;
            this.accept = DFA10_accept;
            this.special = DFA10_special;
            this.transition = DFA10_transition;
        }
        public String getDescription() {
            return "437:5: ( declar )?";
        }
    }
    static final String DFA17_eotS =
        "\16\uffff";
    static final String DFA17_eofS =
        "\16\uffff";
    static final String DFA17_minS =
        "\1\4\2\uffff\1\26\4\uffff\1\4\5\uffff";
    static final String DFA17_maxS =
        "\1\100\2\uffff\1\56\4\uffff\1\62\5\uffff";
    static final String DFA17_acceptS =
        "\1\uffff\1\2\10\uffff\1\1\3\uffff";
    static final String DFA17_specialS =
        "\16\uffff}>";
    static final String[] DFA17_transitionS = {
            "\1\3\63\uffff\6\1\2\uffff\1\1",
            "",
            "",
            "\1\1\21\uffff\1\12\1\uffff\1\1\2\uffff\1\12\1\10",
            "",
            "",
            "",
            "",
            "\1\1\53\uffff\3\12",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA17_eot = DFA.unpackEncodedString(DFA17_eotS);
    static final short[] DFA17_eof = DFA.unpackEncodedString(DFA17_eofS);
    static final char[] DFA17_min = DFA.unpackEncodedStringToUnsignedChars(DFA17_minS);
    static final char[] DFA17_max = DFA.unpackEncodedStringToUnsignedChars(DFA17_maxS);
    static final short[] DFA17_accept = DFA.unpackEncodedString(DFA17_acceptS);
    static final short[] DFA17_special = DFA.unpackEncodedString(DFA17_specialS);
    static final short[][] DFA17_transition;

    static {
        int numStates = DFA17_transitionS.length;
        DFA17_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA17_transition[i] = DFA.unpackEncodedString(DFA17_transitionS[i]);
        }
    }

    class DFA17 extends DFA {

        public DFA17(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 17;
            this.eot = DFA17_eot;
            this.eof = DFA17_eof;
            this.min = DFA17_min;
            this.max = DFA17_max;
            this.accept = DFA17_accept;
            this.special = DFA17_special;
            this.transition = DFA17_transition;
        }
        public String getDescription() {
            return "()+ loopback of 476:5: ( dline_annot modif_annot )+";
        }
    }
    static final String DFA21_eotS =
        "\16\uffff";
    static final String DFA21_eofS =
        "\16\uffff";
    static final String DFA21_minS =
        "\1\4\15\uffff";
    static final String DFA21_maxS =
        "\1\77\15\uffff";
    static final String DFA21_acceptS =
        "\1\uffff\1\1\13\uffff\1\2";
    static final String DFA21_specialS =
        "\16\uffff}>";
    static final String[] DFA21_transitionS = {
            "\4\1\4\uffff\3\1\4\uffff\1\1\4\uffff\2\1\6\uffff\1\1\1\uffff"+
            "\1\1\3\uffff\1\1\1\uffff\1\1\1\15\24\uffff\2\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA21_eot = DFA.unpackEncodedString(DFA21_eotS);
    static final short[] DFA21_eof = DFA.unpackEncodedString(DFA21_eofS);
    static final char[] DFA21_min = DFA.unpackEncodedStringToUnsignedChars(DFA21_minS);
    static final char[] DFA21_max = DFA.unpackEncodedStringToUnsignedChars(DFA21_maxS);
    static final short[] DFA21_accept = DFA.unpackEncodedString(DFA21_acceptS);
    static final short[] DFA21_special = DFA.unpackEncodedString(DFA21_specialS);
    static final short[][] DFA21_transition;

    static {
        int numStates = DFA21_transitionS.length;
        DFA21_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA21_transition[i] = DFA.unpackEncodedString(DFA21_transitionS[i]);
        }
    }

    class DFA21 extends DFA {

        public DFA21(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 21;
            this.eot = DFA21_eot;
            this.eof = DFA21_eof;
            this.min = DFA21_min;
            this.max = DFA21_max;
            this.accept = DFA21_accept;
            this.special = DFA21_special;
            this.transition = DFA21_transition;
        }
        public String getDescription() {
            return "513:7: ( expr )?";
        }
    }
    static final String DFA27_eotS =
        "\105\uffff";
    static final String DFA27_eofS =
        "\105\uffff";
    static final String DFA27_minS =
        "\1\4\2\17\1\4\14\uffff\1\4\23\uffff\1\17\14\uffff\1\0\12\uffff\1"+
        "\0\10\uffff";
    static final String DFA27_maxS =
        "\1\77\2\53\1\77\14\uffff\1\77\23\uffff\1\55\14\uffff\1\0\12\uffff"+
        "\1\0\10\uffff";
    static final String DFA27_acceptS =
        "\4\uffff\1\2\12\uffff\1\3\12\uffff\1\1\52\uffff";
    static final String DFA27_specialS =
        "\61\uffff\1\0\12\uffff\1\1\10\uffff}>";
    static final String[] DFA27_transitionS = {
            "\1\2\1\1\2\4\4\uffff\3\4\4\uffff\1\4\4\uffff\2\4\6\uffff\1\4"+
            "\1\uffff\1\4\3\uffff\1\3\1\uffff\1\4\2\uffff\1\17\22\uffff\2"+
            "\4",
            "\4\4\1\uffff\4\4\2\uffff\1\20\5\4\1\uffff\5\4\2\uffff\1\4\2"+
            "\uffff\1\4",
            "\4\4\1\uffff\4\4\2\uffff\6\4\1\uffff\5\4\1\32\1\uffff\1\4\2"+
            "\uffff\1\4",
            "\1\4\1\44\2\4\4\uffff\3\4\4\uffff\1\4\4\uffff\2\4\6\uffff\1"+
            "\4\1\uffff\1\4\3\uffff\1\4\1\uffff\1\4\25\uffff\2\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\61\3\4\4\uffff\2\4\22\uffff\1\4\1\uffff\1\4\3\uffff\1\4"+
            "\1\uffff\1\4\26\uffff\1\4",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\4\4\1\uffff\4\4\2\uffff\6\4\1\uffff\5\4\1\uffff\1\74\1\4\4"+
            "\uffff\1\32",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "\1\uffff",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA27_eot = DFA.unpackEncodedString(DFA27_eotS);
    static final short[] DFA27_eof = DFA.unpackEncodedString(DFA27_eofS);
    static final char[] DFA27_min = DFA.unpackEncodedStringToUnsignedChars(DFA27_minS);
    static final char[] DFA27_max = DFA.unpackEncodedStringToUnsignedChars(DFA27_maxS);
    static final short[] DFA27_accept = DFA.unpackEncodedString(DFA27_acceptS);
    static final short[] DFA27_special = DFA.unpackEncodedString(DFA27_specialS);
    static final short[][] DFA27_transition;

    static {
        int numStates = DFA27_transitionS.length;
        DFA27_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA27_transition[i] = DFA.unpackEncodedString(DFA27_transitionS[i]);
        }
    }

    class DFA27 extends DFA {

        public DFA27(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 27;
            this.eot = DFA27_eot;
            this.eof = DFA27_eof;
            this.min = DFA27_min;
            this.max = DFA27_max;
            this.accept = DFA27_accept;
            this.special = DFA27_special;
            this.transition = DFA27_transition;
        }
        public String getDescription() {
            return "561:1: label returns [ILabel rL] : ({...}? call_havoc | expr | );";
        }
        public int specialStateTransition(int s, IntStream _input) throws NoViableAltException {
            TokenStream input = (TokenStream)_input;
        	int _s = s;
            switch ( s ) {
                    case 0 : 
                        int LA27_49 = input.LA(1);

                         
                        int index27_49 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (( isCall() )) ) {s = 26;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index27_49);
                        if ( s>=0 ) return s;
                        break;
                    case 1 : 
                        int LA27_60 = input.LA(1);

                         
                        int index27_60 = input.index();
                        input.rewind();
                        s = -1;
                        if ( (( isCall() )) ) {s = 26;}

                        else if ( (true) ) {s = 4;}

                         
                        input.seek(index27_60);
                        if ( s>=0 ) return s;
                        break;
            }
            NoViableAltException nvae =
                new NoViableAltException(getDescription(), 27, _s, input);
            error(nvae);
            throw nvae;
        }
    }
    static final String DFA31_eotS =
        "\16\uffff";
    static final String DFA31_eofS =
        "\16\uffff";
    static final String DFA31_minS =
        "\1\4\15\uffff";
    static final String DFA31_maxS =
        "\1\77\15\uffff";
    static final String DFA31_acceptS =
        "\1\uffff\1\1\13\uffff\1\2";
    static final String DFA31_specialS =
        "\16\uffff}>";
    static final String[] DFA31_transitionS = {
            "\4\1\4\uffff\3\1\4\uffff\1\1\4\uffff\2\1\6\uffff\1\1\1\uffff"+
            "\1\1\3\uffff\1\1\1\15\1\1\25\uffff\2\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA31_eot = DFA.unpackEncodedString(DFA31_eotS);
    static final short[] DFA31_eof = DFA.unpackEncodedString(DFA31_eofS);
    static final char[] DFA31_min = DFA.unpackEncodedStringToUnsignedChars(DFA31_minS);
    static final char[] DFA31_max = DFA.unpackEncodedStringToUnsignedChars(DFA31_maxS);
    static final short[] DFA31_accept = DFA.unpackEncodedString(DFA31_acceptS);
    static final short[] DFA31_special = DFA.unpackEncodedString(DFA31_specialS);
    static final short[][] DFA31_transition;

    static {
        int numStates = DFA31_transitionS.length;
        DFA31_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA31_transition[i] = DFA.unpackEncodedString(DFA31_transitionS[i]);
        }
    }

    class DFA31 extends DFA {

        public DFA31(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 31;
            this.eot = DFA31_eot;
            this.eof = DFA31_eof;
            this.min = DFA31_min;
            this.max = DFA31_max;
            this.accept = DFA31_accept;
            this.special = DFA31_special;
            this.transition = DFA31_transition;
        }
        public String getDescription() {
            return "587:5: ( expr ( COMMA expr )* )?";
        }
    }
    static final String DFA36_eotS =
        "\12\uffff";
    static final String DFA36_eofS =
        "\12\uffff";
    static final String DFA36_minS =
        "\1\17\11\uffff";
    static final String DFA36_maxS =
        "\1\57\11\uffff";
    static final String DFA36_acceptS =
        "\1\uffff\1\2\7\uffff\1\1";
    static final String DFA36_specialS =
        "\12\uffff}>";
    static final String[] DFA36_transitionS = {
            "\1\11\3\1\1\uffff\1\11\3\1\17\uffff\1\1\1\uffff\1\1\1\uffff"+
            "\1\1\1\uffff\1\1\1\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA36_eot = DFA.unpackEncodedString(DFA36_eotS);
    static final short[] DFA36_eof = DFA.unpackEncodedString(DFA36_eofS);
    static final char[] DFA36_min = DFA.unpackEncodedStringToUnsignedChars(DFA36_minS);
    static final char[] DFA36_max = DFA.unpackEncodedStringToUnsignedChars(DFA36_maxS);
    static final short[] DFA36_accept = DFA.unpackEncodedString(DFA36_acceptS);
    static final short[] DFA36_special = DFA.unpackEncodedString(DFA36_specialS);
    static final short[][] DFA36_transition;

    static {
        int numStates = DFA36_transitionS.length;
        DFA36_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA36_transition[i] = DFA.unpackEncodedString(DFA36_transitionS[i]);
        }
    }

    class DFA36 extends DFA {

        public DFA36(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 36;
            this.eot = DFA36_eot;
            this.eof = DFA36_eof;
            this.min = DFA36_min;
            this.max = DFA36_max;
            this.accept = DFA36_accept;
            this.special = DFA36_special;
            this.transition = DFA36_transition;
        }
        public String getDescription() {
            return "()* loopback of 619:9: (op= op_and not )*";
        }
    }
    static final String DFA37_eotS =
        "\15\uffff";
    static final String DFA37_eofS =
        "\15\uffff";
    static final String DFA37_minS =
        "\1\4\14\uffff";
    static final String DFA37_maxS =
        "\1\77\14\uffff";
    static final String DFA37_acceptS =
        "\1\uffff\1\2\12\uffff\1\1";
    static final String DFA37_specialS =
        "\15\uffff}>";
    static final String[] DFA37_transitionS = {
            "\4\1\4\uffff\2\1\1\14\4\uffff\1\14\4\uffff\2\1\6\uffff\1\1\1"+
            "\uffff\1\1\3\uffff\1\1\1\uffff\1\1\25\uffff\2\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA37_eot = DFA.unpackEncodedString(DFA37_eotS);
    static final short[] DFA37_eof = DFA.unpackEncodedString(DFA37_eofS);
    static final char[] DFA37_min = DFA.unpackEncodedStringToUnsignedChars(DFA37_minS);
    static final char[] DFA37_max = DFA.unpackEncodedStringToUnsignedChars(DFA37_maxS);
    static final short[] DFA37_accept = DFA.unpackEncodedString(DFA37_acceptS);
    static final short[] DFA37_special = DFA.unpackEncodedString(DFA37_specialS);
    static final short[][] DFA37_transition;

    static {
        int numStates = DFA37_transitionS.length;
        DFA37_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA37_transition[i] = DFA.unpackEncodedString(DFA37_transitionS[i]);
        }
    }

    class DFA37 extends DFA {

        public DFA37(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 37;
            this.eot = DFA37_eot;
            this.eof = DFA37_eof;
            this.min = DFA37_min;
            this.max = DFA37_max;
            this.accept = DFA37_accept;
            this.special = DFA37_special;
            this.transition = DFA37_transition;
        }
        public String getDescription() {
            return "()* loopback of 623:5: (op= op_not )*";
        }
    }
    static final String DFA38_eotS =
        "\14\uffff";
    static final String DFA38_eofS =
        "\14\uffff";
    static final String DFA38_minS =
        "\1\4\13\uffff";
    static final String DFA38_maxS =
        "\1\77\13\uffff";
    static final String DFA38_acceptS =
        "\1\uffff\1\1\1\2\1\3\10\uffff";
    static final String DFA38_specialS =
        "\14\uffff}>";
    static final String[] DFA38_transitionS = {
            "\4\3\4\uffff\2\3\12\uffff\2\2\6\uffff\1\3\1\uffff\1\3\3\uffff"+
            "\1\3\1\uffff\1\3\25\uffff\1\1\1\3",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA38_eot = DFA.unpackEncodedString(DFA38_eotS);
    static final short[] DFA38_eof = DFA.unpackEncodedString(DFA38_eofS);
    static final char[] DFA38_min = DFA.unpackEncodedStringToUnsignedChars(DFA38_minS);
    static final char[] DFA38_max = DFA.unpackEncodedStringToUnsignedChars(DFA38_maxS);
    static final short[] DFA38_accept = DFA.unpackEncodedString(DFA38_acceptS);
    static final short[] DFA38_special = DFA.unpackEncodedString(DFA38_specialS);
    static final short[][] DFA38_transition;

    static {
        int numStates = DFA38_transitionS.length;
        DFA38_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA38_transition[i] = DFA.unpackEncodedString(DFA38_transitionS[i]);
        }
    }

    class DFA38 extends DFA {

        public DFA38(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 38;
            this.eot = DFA38_eot;
            this.eof = DFA38_eof;
            this.min = DFA38_min;
            this.max = DFA38_max;
            this.accept = DFA38_accept;
            this.special = DFA38_special;
            this.transition = DFA38_transition;
        }
        public String getDescription() {
            return "629:1: predicate : ( havoc | quant | pred_rop );";
        }
    }
    static final String DFA39_eotS =
        "\13\uffff";
    static final String DFA39_eofS =
        "\13\uffff";
    static final String DFA39_minS =
        "\1\17\12\uffff";
    static final String DFA39_maxS =
        "\1\57\12\uffff";
    static final String DFA39_acceptS =
        "\1\uffff\1\1\1\2\10\uffff";
    static final String DFA39_specialS =
        "\13\uffff}>";
    static final String[] DFA39_transitionS = {
            "\4\2\1\uffff\4\2\2\uffff\6\1\7\uffff\1\2\1\uffff\1\2\1\uffff"+
            "\1\2\1\uffff\1\2\1\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA39_eot = DFA.unpackEncodedString(DFA39_eotS);
    static final short[] DFA39_eof = DFA.unpackEncodedString(DFA39_eofS);
    static final char[] DFA39_min = DFA.unpackEncodedStringToUnsignedChars(DFA39_minS);
    static final char[] DFA39_max = DFA.unpackEncodedStringToUnsignedChars(DFA39_maxS);
    static final short[] DFA39_accept = DFA.unpackEncodedString(DFA39_acceptS);
    static final short[] DFA39_special = DFA.unpackEncodedString(DFA39_specialS);
    static final short[][] DFA39_transition;

    static {
        int numStates = DFA39_transitionS.length;
        DFA39_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA39_transition[i] = DFA.unpackEncodedString(DFA39_transitionS[i]);
        }
    }

    class DFA39 extends DFA {

        public DFA39(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 39;
            this.eot = DFA39_eot;
            this.eof = DFA39_eof;
            this.min = DFA39_min;
            this.max = DFA39_max;
            this.accept = DFA39_accept;
            this.special = DFA39_special;
            this.transition = DFA39_transition;
        }
        public String getDescription() {
            return "636:5: (op= rop plusminus )?";
        }
    }
    static final String DFA40_eotS =
        "\14\uffff";
    static final String DFA40_eofS =
        "\14\uffff";
    static final String DFA40_minS =
        "\1\17\13\uffff";
    static final String DFA40_maxS =
        "\1\57\13\uffff";
    static final String DFA40_acceptS =
        "\1\uffff\1\2\11\uffff\1\1";
    static final String DFA40_specialS =
        "\14\uffff}>";
    static final String[] DFA40_transitionS = {
            "\4\1\1\uffff\4\1\2\uffff\6\1\1\uffff\2\13\4\uffff\1\1\1\uffff"+
            "\1\1\1\uffff\1\1\1\uffff\1\1\1\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA40_eot = DFA.unpackEncodedString(DFA40_eotS);
    static final short[] DFA40_eof = DFA.unpackEncodedString(DFA40_eofS);
    static final char[] DFA40_min = DFA.unpackEncodedStringToUnsignedChars(DFA40_minS);
    static final char[] DFA40_max = DFA.unpackEncodedStringToUnsignedChars(DFA40_maxS);
    static final short[] DFA40_accept = DFA.unpackEncodedString(DFA40_acceptS);
    static final short[] DFA40_special = DFA.unpackEncodedString(DFA40_specialS);
    static final short[][] DFA40_transition;

    static {
        int numStates = DFA40_transitionS.length;
        DFA40_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA40_transition[i] = DFA.unpackEncodedString(DFA40_transitionS[i]);
        }
    }

    class DFA40 extends DFA {

        public DFA40(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 40;
            this.eot = DFA40_eot;
            this.eof = DFA40_eof;
            this.min = DFA40_min;
            this.max = DFA40_max;
            this.accept = DFA40_accept;
            this.special = DFA40_special;
            this.transition = DFA40_transition;
        }
        public String getDescription() {
            return "()* loopback of 665:5: (op= pm mult_div_rem )*";
        }
    }
    static final String DFA41_eotS =
        "\15\uffff";
    static final String DFA41_eofS =
        "\15\uffff";
    static final String DFA41_minS =
        "\1\17\14\uffff";
    static final String DFA41_maxS =
        "\1\57\14\uffff";
    static final String DFA41_acceptS =
        "\1\uffff\1\2\12\uffff\1\1";
    static final String DFA41_specialS =
        "\15\uffff}>";
    static final String[] DFA41_transitionS = {
            "\4\1\1\uffff\4\1\2\uffff\6\1\1\uffff\2\1\3\14\1\uffff\1\1\1"+
            "\uffff\1\1\1\uffff\1\1\1\uffff\1\1\1\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA41_eot = DFA.unpackEncodedString(DFA41_eotS);
    static final short[] DFA41_eof = DFA.unpackEncodedString(DFA41_eofS);
    static final char[] DFA41_min = DFA.unpackEncodedStringToUnsignedChars(DFA41_minS);
    static final char[] DFA41_max = DFA.unpackEncodedStringToUnsignedChars(DFA41_maxS);
    static final short[] DFA41_accept = DFA.unpackEncodedString(DFA41_acceptS);
    static final short[] DFA41_special = DFA.unpackEncodedString(DFA41_specialS);
    static final short[][] DFA41_transition;

    static {
        int numStates = DFA41_transitionS.length;
        DFA41_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA41_transition[i] = DFA.unpackEncodedString(DFA41_transitionS[i]);
        }
    }

    class DFA41 extends DFA {

        public DFA41(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 41;
            this.eot = DFA41_eot;
            this.eof = DFA41_eof;
            this.min = DFA41_min;
            this.max = DFA41_max;
            this.accept = DFA41_accept;
            this.special = DFA41_special;
            this.transition = DFA41_transition;
        }
        public String getDescription() {
            return "()* loopback of 677:5: (op= mdr un_plusminus )*";
        }
    }
    static final String DFA42_eotS =
        "\12\uffff";
    static final String DFA42_eofS =
        "\12\uffff";
    static final String DFA42_minS =
        "\1\4\11\uffff";
    static final String DFA42_maxS =
        "\1\77\11\uffff";
    static final String DFA42_acceptS =
        "\1\uffff\1\1\1\2\7\uffff";
    static final String DFA42_specialS =
        "\12\uffff}>";
    static final String[] DFA42_transitionS = {
            "\4\2\4\uffff\2\2\22\uffff\1\2\1\uffff\1\1\3\uffff\1\2\1\uffff"+
            "\1\2\26\uffff\1\2",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA42_eot = DFA.unpackEncodedString(DFA42_eotS);
    static final short[] DFA42_eof = DFA.unpackEncodedString(DFA42_eofS);
    static final char[] DFA42_min = DFA.unpackEncodedStringToUnsignedChars(DFA42_minS);
    static final char[] DFA42_max = DFA.unpackEncodedStringToUnsignedChars(DFA42_maxS);
    static final short[] DFA42_accept = DFA.unpackEncodedString(DFA42_acceptS);
    static final short[] DFA42_special = DFA.unpackEncodedString(DFA42_specialS);
    static final short[][] DFA42_transition;

    static {
        int numStates = DFA42_transitionS.length;
        DFA42_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA42_transition[i] = DFA.unpackEncodedString(DFA42_transitionS[i]);
        }
    }

    class DFA42 extends DFA {

        public DFA42(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 42;
            this.eot = DFA42_eot;
            this.eof = DFA42_eof;
            this.min = DFA42_min;
            this.max = DFA42_max;
            this.accept = DFA42_accept;
            this.special = DFA42_special;
            this.transition = DFA42_transition;
        }
        public String getDescription() {
            return "689:5: (m= MINUS )?";
        }
    }
    static final String DFA46_eotS =
        "\17\uffff";
    static final String DFA46_eofS =
        "\17\uffff";
    static final String DFA46_minS =
        "\1\17\16\uffff";
    static final String DFA46_maxS =
        "\1\57\16\uffff";
    static final String DFA46_acceptS =
        "\1\uffff\1\2\14\uffff\1\1";
    static final String DFA46_specialS =
        "\17\uffff}>";
    static final String[] DFA46_transitionS = {
            "\4\1\1\uffff\4\1\2\uffff\14\1\1\uffff\1\1\1\16\1\1\1\uffff\1"+
            "\1\1\uffff\1\1\1\uffff\1\1",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            "",
            ""
    };

    static final short[] DFA46_eot = DFA.unpackEncodedString(DFA46_eotS);
    static final short[] DFA46_eof = DFA.unpackEncodedString(DFA46_eofS);
    static final char[] DFA46_min = DFA.unpackEncodedStringToUnsignedChars(DFA46_minS);
    static final char[] DFA46_max = DFA.unpackEncodedStringToUnsignedChars(DFA46_maxS);
    static final short[] DFA46_accept = DFA.unpackEncodedString(DFA46_acceptS);
    static final short[] DFA46_special = DFA.unpackEncodedString(DFA46_specialS);
    static final short[][] DFA46_transition;

    static {
        int numStates = DFA46_transitionS.length;
        DFA46_transition = new short[numStates][];
        for (int i=0; i<numStates; i++) {
            DFA46_transition[i] = DFA.unpackEncodedString(DFA46_transitionS[i]);
        }
    }

    class DFA46 extends DFA {

        public DFA46(BaseRecognizer recognizer) {
            this.recognizer = recognizer;
            this.decisionNumber = 46;
            this.eot = DFA46_eot;
            this.eof = DFA46_eof;
            this.min = DFA46_min;
            this.max = DFA46_max;
            this.accept = DFA46_accept;
            this.special = DFA46_special;
            this.transition = DFA46_transition;
        }
        public String getDescription() {
            return "()* loopback of 725:5: ( LPAR_S e1= expr ( COMMA expr )* RPAR_S )*";
        }
    }
 

    public static final BitSet FOLLOW_nts_in_start687 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_start689 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_declar_in_start_expr702 = new BitSet(new long[]{0x0000000000000000L,0x0000000000000001L});
    public static final BitSet FOLLOW_RELATION_in_start_expr704 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_start_expr707 = new BitSet(new long[]{0x0000800000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_start_expr709 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_EOF_in_start_expr713 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotations_in_nts736 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_NTS_in_nts747 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_nts749 = new BitSet(new long[]{0x0000800000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_nts751 = new BitSet(new long[]{0x00E0000000000400L});
    public static final BitSet FOLLOW_modif_annot_in_nts791 = new BitSet(new long[]{0x3000000000000010L});
    public static final BitSet FOLLOW_declar_m_a_in_nts809 = new BitSet(new long[]{0x3000000000000010L});
    public static final BitSet FOLLOW_precondition_in_nts854 = new BitSet(new long[]{0x3000000000000410L});
    public static final BitSet FOLLOW_annotations_in_nts869 = new BitSet(new long[]{0x3000000000000010L});
    public static final BitSet FOLLOW_instances_in_nts902 = new BitSet(new long[]{0x3000000000000410L});
    public static final BitSet FOLLOW_annotations_in_nts917 = new BitSet(new long[]{0x3000000000000010L});
    public static final BitSet FOLLOW_subsystem_annot_in_nts940 = new BitSet(new long[]{0x3000000000000412L});
    public static final BitSet FOLLOW_subsystem_in_nts944 = new BitSet(new long[]{0x3000000000000412L});
    public static final BitSet FOLLOW_PRECONDITION_in_precondition970 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_precondition972 = new BitSet(new long[]{0x0000800000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_precondition974 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INSTANCES_in_instances989 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_inst_in_instances991 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_COMMA_in_instances994 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_inst_in_instances996 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_instances1000 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDN_in_inst1014 = new BitSet(new long[]{0x0000010000000000L});
    public static final BitSet FOLLOW_LPAR_S_in_inst1016 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_inst1020 = new BitSet(new long[]{0x0000020000000000L});
    public static final BitSet FOLLOW_RPAR_S_in_inst1022 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotation_in_annotations1055 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_annotation_in_annotations1065 = new BitSet(new long[]{0x0000000000000402L});
    public static final BitSet FOLLOW_AT_in_annotation1087 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_annotation1091 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_COLON_in_annotation1093 = new BitSet(new long[]{0x001F000000000000L});
    public static final BitSet FOLLOW_annot_type_in_annotation1101 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_COLON_in_annotation1103 = new BitSet(new long[]{0xC0000145030870F0L,0x0000000000000004L});
    public static final BitSet FOLLOW_annot_value_in_annotation1110 = new BitSet(new long[]{0x0000800000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_annotation1113 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_litstring_in_annot_value1130 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_annot_value1140 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_annot_type1160 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LITSTRING_in_litstring1198 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotations_in_subsystem1222 = new BitSet(new long[]{0x3000000000000010L});
    public static final BitSet FOLLOW_subsystem_annot_in_subsystem1224 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDN_in_subsystem_annot1236 = new BitSet(new long[]{0x0000040000000000L});
    public static final BitSet FOLLOW_LPAR_C_in_subsystem_annot1238 = new BitSet(new long[]{0x0FE0000000000410L});
    public static final BitSet FOLLOW_declar_in_subsystem_annot1256 = new BitSet(new long[]{0x0FE0000000000410L});
    public static final BitSet FOLLOW_marking_in_subsystem_annot1270 = new BitSet(new long[]{0x0FE0000000000410L});
    public static final BitSet FOLLOW_transition_in_subsystem_annot1277 = new BitSet(new long[]{0x0FE0080000000410L});
    public static final BitSet FOLLOW_RPAR_C_in_subsystem_annot1282 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_STATES_in_marking1302 = new BitSet(new long[]{0x0000000000000410L});
    public static final BitSet FOLLOW_annotations_in_marking1310 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_marking1314 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_COMMA_in_marking1326 = new BitSet(new long[]{0x0000000000000410L});
    public static final BitSet FOLLOW_annotations_in_marking1328 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_marking1332 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_marking1351 = new BitSet(new long[]{0x0E00000000000000L});
    public static final BitSet FOLLOW_set_in_marking1379 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_marking1416 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_COMMA_in_marking1428 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_marking1432 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_marking1461 = new BitSet(new long[]{0x0E00000000000002L});
    public static final BitSet FOLLOW_modif_annot_in_declar1488 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_declar_m_a_in_declar1490 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_dline_annot_in_declar_m_a1505 = new BitSet(new long[]{0x00E0000000000400L});
    public static final BitSet FOLLOW_modif_annot_in_declar_m_a1507 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_modifier_in_modif_annot1523 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_annotations_in_modif_annot1525 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_modifier1540 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_dblock_annot_in_dline_annot1571 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_COMMA_in_dline_annot1575 = new BitSet(new long[]{0x0000000000000410L});
    public static final BitSet FOLLOW_dblock_in_dline_annot1577 = new BitSet(new long[]{0x0000A00000000000L});
    public static final BitSet FOLLOW_SEMICOLON_in_dline_annot1582 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotations_in_dblock1595 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_dblock_annot_in_dblock1597 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_dvar_annot_in_dblock_annot1610 = new BitSet(new long[]{0x0000600000000000L});
    public static final BitSet FOLLOW_COMMA_in_dblock_annot1613 = new BitSet(new long[]{0x0000000000000410L});
    public static final BitSet FOLLOW_dvar_in_dblock_annot1615 = new BitSet(new long[]{0x0000600000000000L});
    public static final BitSet FOLLOW_COLON_in_dblock_annot1620 = new BitSet(new long[]{0x0007000000000000L});
    public static final BitSet FOLLOW_basic_type_in_dblock_annot1622 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_annotations_in_dvar1641 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_dvar_annot_in_dvar1643 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDN_in_dvar_annot1664 = new BitSet(new long[]{0x0000010000000002L});
    public static final BitSet FOLLOW_LPAR_S_in_dvar_annot1672 = new BitSet(new long[]{0xC0000345030870F0L});
    public static final BitSet FOLLOW_expr_in_dvar_annot1691 = new BitSet(new long[]{0x0000020000000000L});
    public static final BitSet FOLLOW_RPAR_S_in_dvar_annot1728 = new BitSet(new long[]{0x0000010000000002L});
    public static final BitSet FOLLOW_set_in_basic_type1760 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_qd_block_in_qdecl1790 = new BitSet(new long[]{0x0000300000000000L});
    public static final BitSet FOLLOW_COMMA_in_qdecl1794 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_qd_block_in_qdecl1796 = new BitSet(new long[]{0x0000300000000000L});
    public static final BitSet FOLLOW_DOT_in_qdecl1801 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDN_in_qd_block1816 = new BitSet(new long[]{0x0000600000000000L});
    public static final BitSet FOLLOW_COMMA_in_qd_block1827 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_qd_block1831 = new BitSet(new long[]{0x0000600000000000L});
    public static final BitSet FOLLOW_COLON_in_qd_block1843 = new BitSet(new long[]{0x0007000000000000L});
    public static final BitSet FOLLOW_qd_type_in_qd_block1845 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_basic_type_in_qd_type1860 = new BitSet(new long[]{0x0000010000000002L});
    public static final BitSet FOLLOW_LPAR_S_in_qd_type1868 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_qd_type1870 = new BitSet(new long[]{0x0000200000000000L});
    public static final BitSet FOLLOW_COMMA_in_qd_type1872 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_qd_type1874 = new BitSet(new long[]{0x0000020000000000L});
    public static final BitSet FOLLOW_RPAR_S_in_qd_type1876 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDN_in_transition1906 = new BitSet(new long[]{0x0000400000000000L});
    public static final BitSet FOLLOW_COLON_in_transition1908 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_transition1915 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_C_IMPL_in_transition1917 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_transition1921 = new BitSet(new long[]{0x0000040000000400L});
    public static final BitSet FOLLOW_annotations_in_transition1925 = new BitSet(new long[]{0x0000040000000000L});
    public static final BitSet FOLLOW_LPAR_C_in_transition1927 = new BitSet(new long[]{0xC0000945030870F0L});
    public static final BitSet FOLLOW_label_in_transition1931 = new BitSet(new long[]{0x0000080000000000L});
    public static final BitSet FOLLOW_RPAR_C_in_transition1933 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_call_havoc_in_label1957 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_expr_in_label1965 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_call_in_call_havoc1996 = new BitSet(new long[]{0x0000000000108002L});
    public static final BitSet FOLLOW_op_and_in_call_havoc2003 = new BitSet(new long[]{0x4000000000000000L});
    public static final BitSet FOLLOW_havoc_in_call_havoc2005 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ret_idp_in_call2032 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_EQ_in_call2038 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_call2_in_call2040 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_call2_in_call2047 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_call2054 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_retlist_in_call2056 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_RPAR_in_call2058 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_EQ_in_call2060 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_call2_in_call2062 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDN_in_call22076 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_LPAR_in_call22084 = new BitSet(new long[]{0xC00001C5030870F0L});
    public static final BitSet FOLLOW_expr_in_call22092 = new BitSet(new long[]{0x0000208000000000L});
    public static final BitSet FOLLOW_COMMA_in_call22105 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_call22107 = new BitSet(new long[]{0x0000208000000000L});
    public static final BitSet FOLLOW_RPAR_in_call22129 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ret_idp_in_retlist2141 = new BitSet(new long[]{0x0000200000000002L});
    public static final BitSet FOLLOW_COMMA_in_retlist2145 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_ret_idp_in_retlist2147 = new BitSet(new long[]{0x0000200000000002L});
    public static final BitSet FOLLOW_IDP_in_ret_idp2162 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_equiv_in_expr2186 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_impl_in_equiv2198 = new BitSet(new long[]{0x0000000000840002L});
    public static final BitSet FOLLOW_op_equiv_in_equiv2204 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_impl_in_equiv2206 = new BitSet(new long[]{0x0000000000840002L});
    public static final BitSet FOLLOW_or_in_impl2223 = new BitSet(new long[]{0x0000000000420002L});
    public static final BitSet FOLLOW_op_impl_in_impl2229 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_or_in_impl2231 = new BitSet(new long[]{0x0000000000420002L});
    public static final BitSet FOLLOW_and_in_or2248 = new BitSet(new long[]{0x0000000000210002L});
    public static final BitSet FOLLOW_op_or_in_or2254 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_and_in_or2256 = new BitSet(new long[]{0x0000000000210002L});
    public static final BitSet FOLLOW_not_in_and2273 = new BitSet(new long[]{0x0000000000108002L});
    public static final BitSet FOLLOW_op_and_in_and2279 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_not_in_and2281 = new BitSet(new long[]{0x0000000000108002L});
    public static final BitSet FOLLOW_op_not_in_not2307 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_predicate_in_not2314 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_havoc_in_predicate2333 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_quant_in_predicate2339 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_pred_rop_in_predicate2346 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_plusminus_in_pred_rop2358 = new BitSet(new long[]{0x00000000FC000002L});
    public static final BitSet FOLLOW_rop_in_pred_rop2368 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_plusminus_in_pred_rop2370 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_quantifier_in_quant2401 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_qdecl_in_quant2418 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_predicate_in_quant2428 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_mult_div_rem_in_plusminus2451 = new BitSet(new long[]{0x0000000600000002L});
    public static final BitSet FOLLOW_pm_in_plusminus2462 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_mult_div_rem_in_plusminus2464 = new BitSet(new long[]{0x0000000600000002L});
    public static final BitSet FOLLOW_un_plusminus_in_mult_div_rem2492 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_mdr_in_mult_div_rem2503 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_un_plusminus_in_mult_div_rem2505 = new BitSet(new long[]{0x0000003800000002L});
    public static final BitSet FOLLOW_MINUS_in_un_plusminus2536 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_atom_in_un_plusminus2540 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_access_in_atom2558 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_literal_in_atom2564 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_many_expr_in_atom2570 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_arrsize_in_atom2576 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_in_atom2582 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_atom2584 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_RPAR_in_atom2586 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LPAR_S_in_many_expr2606 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_many_expr2616 = new BitSet(new long[]{0x0000220000000000L});
    public static final BitSet FOLLOW_COMMA_in_many_expr2628 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_many_expr2632 = new BitSet(new long[]{0x0000220000000000L});
    public static final BitSet FOLLOW_RPAR_S_in_many_expr2643 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_VBAR_in_arrsize2669 = new BitSet(new long[]{0x8000000000000030L});
    public static final BitSet FOLLOW_access_in_arrsize2678 = new BitSet(new long[]{0x0000000100000000L});
    public static final BitSet FOLLOW_VBAR_in_arrsize2680 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_id_in_access2702 = new BitSet(new long[]{0x0000010000000002L});
    public static final BitSet FOLLOW_LPAR_S_in_access2761 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_access2765 = new BitSet(new long[]{0x0000220000000000L});
    public static final BitSet FOLLOW_COMMA_in_access2777 = new BitSet(new long[]{0xC0000145030870F0L});
    public static final BitSet FOLLOW_expr_in_access2779 = new BitSet(new long[]{0x0000220000000000L});
    public static final BitSet FOLLOW_RPAR_S_in_access2792 = new BitSet(new long[]{0x0000010000000002L});
    public static final BitSet FOLLOW_HAVOC_in_havoc2847 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_LPAR_in_havoc2849 = new BitSet(new long[]{0x0000008000000010L});
    public static final BitSet FOLLOW_IDN_in_havoc2869 = new BitSet(new long[]{0x0000208000000000L});
    public static final BitSet FOLLOW_COMMA_in_havoc2881 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDN_in_havoc2885 = new BitSet(new long[]{0x0000208000000000L});
    public static final BitSet FOLLOW_RPAR_in_havoc2910 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_id0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_boollit_in_literal2958 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LITINT_in_literal2966 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_LITREAL_in_literal2976 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_TRUE_in_boollit2990 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_FALSE_in_boollit2998 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_pm0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_mdr0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_rop0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_quantifier0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_op_equiv0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_op_impl0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_op_or0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_op_and0 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_op_not0 = new BitSet(new long[]{0x0000000000000002L});

}
